/*===========================================================================*/
/*   (Bee/binvoke.scm)                                                       */
/*   Bigloo (4.6a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Jan 27 07:55:05 AM CET 2025     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/bin/bigloo -ldopt -L/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/libbacktrace/usr/lib64/bigloo/4.6a  -afile .afile -no-hello -rm -L /builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/lib/bigloo/4.6a -O5 -unsafe -c Bee/binvoke.scm -o Bee/binvoke.o) */
/* GC selection */
#define THE_GC BOEHM_GC

/* unsafe mode */
#define BIGLOO_UNSAFE 1

/* traces mode */
#define BIGLOO_TRACE 0

/* standard Bigloo include */
#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif
#ifndef BGL_MODULE_TYPE_DEFINITIONS
#define BGL_MODULE_TYPE_DEFINITIONS
#ifndef BGL_BEE_INVOKE_TYPE_DEFINITIONS
#define BGL_BEE_INVOKE_TYPE_DEFINITIONS
#endif // BGL_BEE_INVOKE_TYPE_DEFINITIONS
#endif // BGL_MODULE_TYPE_DEFINITIONS

static obj_t BGl_requirezd2initializa7ationz75zzbee_invokez00 = BUNSPEC;
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
BGL_IMPORT obj_t bgl_reverse(obj_t);
static obj_t BGl_genericzd2initzd2zzbee_invokez00(void);
static obj_t BGl_objectzd2initzd2zzbee_invokez00(void);
BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zzbee_invokez00(void);
static obj_t BGl_z62beezd2callzb0zzbee_invokez00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzbee_invokez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzbee_invokez00(void);
static obj_t BGl_importedzd2moduleszd2initz00zzbee_invokez00(void);
static obj_t BGl_gczd2rootszd2initz00zzbee_invokez00(void);
BGL_EXPORTED_DECL obj_t BGl_beezd2callzd2zzbee_invokez00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_beezd2notifyzd2zzbee_invokez00(obj_t, obj_t);
extern obj_t BGl_za2binza2z00zzengine_paramz00;
extern obj_t BGl_za2boutza2z00zzengine_paramz00;
static obj_t BGl_z62beezd2notifyzb0zzbee_invokez00(obj_t, obj_t, obj_t);
static obj_t *__cnst;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_beezd2notifyzd2envz00zzbee_invokez00, BgL_bgl_za762beeza7d2notifyza71049za7, va_generic_entry, BGl_z62beezd2notifyzb0zzbee_invokez00, BUNSPEC, -2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_beezd2callzd2envz00zzbee_invokez00, BgL_bgl_za762beeza7d2callza7b01050za7, va_generic_entry, BGl_z62beezd2callzb0zzbee_invokez00, BUNSPEC, -2 );
DEFINE_STRING( BGl_string1043z00zzbee_invokez00, BgL_bgl_string1043za700za7za7b1051za7, " ", 1 );
DEFINE_STRING( BGl_string1044z00zzbee_invokez00, BgL_bgl_string1044za700za7za7b1052za7, "(", 1 );
DEFINE_STRING( BGl_string1045z00zzbee_invokez00, BgL_bgl_string1045za700za7za7b1053za7, "\" ", 2 );
DEFINE_STRING( BGl_string1046z00zzbee_invokez00, BgL_bgl_string1046za700za7za7b1054za7, "\"", 1 );
DEFINE_STRING( BGl_string1047z00zzbee_invokez00, BgL_bgl_string1047za700za7za7b1055za7, ")", 1 );
DEFINE_STRING( BGl_string1048z00zzbee_invokez00, BgL_bgl_string1048za700za7za7b1056za7, "bee_invoke", 10 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zzbee_invokez00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzbee_invokez00(long BgL_checksumz00_130, char * BgL_fromz00_131)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzbee_invokez00))
{ 
BGl_requirezd2initializa7ationz75zzbee_invokez00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zzbee_invokez00(); 
BGl_libraryzd2moduleszd2initz00zzbee_invokez00(); 
BGl_importedzd2moduleszd2initz00zzbee_invokez00(); 
return 
BGl_methodzd2initzd2zzbee_invokez00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzbee_invokez00(void)
{
{ /* Bee/binvoke.scm 14 */
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(0L, "bee_invoke"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(0L, "bee_invoke"); 
BGl_modulezd2initializa7ationz75zz__readerz00(0L, "bee_invoke"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(0L, "bee_invoke"); 
return BUNSPEC;} 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zzbee_invokez00(void)
{
{ /* Bee/binvoke.scm 14 */
return 
bgl_gc_roots_register();} 

}



/* bee-call */
BGL_EXPORTED_DEF obj_t BGl_beezd2callzd2zzbee_invokez00(obj_t BgL_funz00_3, obj_t BgL_argsz00_4)
{
{ /* Bee/binvoke.scm 24 */
{ /* Bee/binvoke.scm 26 */
 obj_t BgL_cmdz00_16;
{ 

if(
NULLP(BgL_argsz00_4))
{ /* Bee/binvoke.scm 26 */
BgL_cmdz00_16 = 
string_append_3(BGl_string1044z00zzbee_invokez00, BgL_funz00_3, BGl_string1047z00zzbee_invokez00); }  else 
{ /* Bee/binvoke.scm 26 */
{ /* Bee/binvoke.scm 30 */
 obj_t BgL_g1011z00_24;
BgL_g1011z00_24 = 
bgl_reverse(BgL_argsz00_4); 
{ 
 obj_t BgL_cmdz00_65; obj_t BgL_resz00_66;
BgL_cmdz00_65 = BgL_g1011z00_24; 
BgL_resz00_66 = BGl_string1047z00zzbee_invokez00; 
BgL_loopz00_64:
if(
NULLP(BgL_cmdz00_65))
{ /* Bee/binvoke.scm 33 */
 obj_t BgL_list1022z00_68;
{ /* Bee/binvoke.scm 33 */
 obj_t BgL_arg1023z00_69;
{ /* Bee/binvoke.scm 33 */
 obj_t BgL_arg1024z00_70;
{ /* Bee/binvoke.scm 33 */
 obj_t BgL_arg1025z00_71;
BgL_arg1025z00_71 = 
MAKE_YOUNG_PAIR(BgL_resz00_66, BNIL); 
BgL_arg1024z00_70 = 
MAKE_YOUNG_PAIR(BGl_string1043z00zzbee_invokez00, BgL_arg1025z00_71); } 
BgL_arg1023z00_69 = 
MAKE_YOUNG_PAIR(BgL_funz00_3, BgL_arg1024z00_70); } 
BgL_list1022z00_68 = 
MAKE_YOUNG_PAIR(BGl_string1044z00zzbee_invokez00, BgL_arg1023z00_69); } 
BgL_cmdz00_16 = 
BGl_stringzd2appendzd2zz__r4_strings_6_7z00(BgL_list1022z00_68); }  else 
{ /* Bee/binvoke.scm 34 */
 obj_t BgL_arg1026z00_72; obj_t BgL_arg1027z00_73;
BgL_arg1026z00_72 = 
CDR(
((obj_t)BgL_cmdz00_65)); 
{ /* Bee/binvoke.scm 35 */
 obj_t BgL_arg1028z00_75;
BgL_arg1028z00_75 = 
CAR(
((obj_t)BgL_cmdz00_65)); 
{ /* Bee/binvoke.scm 35 */
 obj_t BgL_list1029z00_77;
{ /* Bee/binvoke.scm 35 */
 obj_t BgL_arg1030z00_78;
{ /* Bee/binvoke.scm 35 */
 obj_t BgL_arg1031z00_79;
{ /* Bee/binvoke.scm 35 */
 obj_t BgL_arg1032z00_80;
BgL_arg1032z00_80 = 
MAKE_YOUNG_PAIR(BgL_resz00_66, BNIL); 
BgL_arg1031z00_79 = 
MAKE_YOUNG_PAIR(BGl_string1045z00zzbee_invokez00, BgL_arg1032z00_80); } 
BgL_arg1030z00_78 = 
MAKE_YOUNG_PAIR(BgL_arg1028z00_75, BgL_arg1031z00_79); } 
BgL_list1029z00_77 = 
MAKE_YOUNG_PAIR(BGl_string1046z00zzbee_invokez00, BgL_arg1030z00_78); } 
BgL_arg1027z00_73 = 
BGl_stringzd2appendzd2zz__r4_strings_6_7z00(BgL_list1029z00_77); } } 
{ 
 obj_t BgL_resz00_165; obj_t BgL_cmdz00_164;
BgL_cmdz00_164 = BgL_arg1026z00_72; 
BgL_resz00_165 = BgL_arg1027z00_73; 
BgL_resz00_66 = BgL_resz00_165; 
BgL_cmdz00_65 = BgL_cmdz00_164; 
goto BgL_loopz00_64;} } } } } } 
{ /* Bee/binvoke.scm 37 */
 obj_t BgL_port1013z00_17;
BgL_port1013z00_17 = BGl_za2boutza2z00zzengine_paramz00; 
bgl_display_obj(BgL_cmdz00_16, BgL_port1013z00_17); 
{ /* Bee/binvoke.scm 37 */
 obj_t BgL_tmpz00_167;
BgL_tmpz00_167 = 
((obj_t)BgL_port1013z00_17); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_167); } } 
{ /* Bee/binvoke.scm 39 */

{ /* Bee/binvoke.scm 39 */
 obj_t BgL_iportz00_18;
BgL_iportz00_18 = BGl_za2binza2z00zzengine_paramz00; 
{ /* Bee/binvoke.scm 39 */

return 
BGl_readz00zz__readerz00(BgL_iportz00_18, BFALSE);} } } } } 

}



/* &bee-call */
obj_t BGl_z62beezd2callzb0zzbee_invokez00(obj_t BgL_envz00_124, obj_t BgL_funz00_125, obj_t BgL_argsz00_126)
{
{ /* Bee/binvoke.scm 24 */
return 
BGl_beezd2callzd2zzbee_invokez00(BgL_funz00_125, BgL_argsz00_126);} 

}



/* bee-notify */
BGL_EXPORTED_DEF obj_t BGl_beezd2notifyzd2zzbee_invokez00(obj_t BgL_funz00_5, obj_t BgL_argsz00_6)
{
{ /* Bee/binvoke.scm 46 */
{ /* Bee/binvoke.scm 48 */
 obj_t BgL_cmdz00_42;
{ 

if(
NULLP(BgL_argsz00_6))
{ /* Bee/binvoke.scm 48 */
BgL_cmdz00_42 = 
string_append_3(BGl_string1044z00zzbee_invokez00, BgL_funz00_5, BGl_string1047z00zzbee_invokez00); }  else 
{ /* Bee/binvoke.scm 48 */
{ /* Bee/binvoke.scm 52 */
 obj_t BgL_g1012z00_48;
BgL_g1012z00_48 = 
bgl_reverse(BgL_argsz00_6); 
{ 
 obj_t BgL_cmdz00_103; obj_t BgL_resz00_104;
BgL_cmdz00_103 = BgL_g1012z00_48; 
BgL_resz00_104 = BGl_string1047z00zzbee_invokez00; 
BgL_loopz00_102:
if(
NULLP(BgL_cmdz00_103))
{ /* Bee/binvoke.scm 55 */
 obj_t BgL_list1036z00_114;
{ /* Bee/binvoke.scm 55 */
 obj_t BgL_arg1037z00_115;
{ /* Bee/binvoke.scm 55 */
 obj_t BgL_arg1038z00_116;
{ /* Bee/binvoke.scm 55 */
 obj_t BgL_arg1039z00_117;
BgL_arg1039z00_117 = 
MAKE_YOUNG_PAIR(BgL_resz00_104, BNIL); 
BgL_arg1038z00_116 = 
MAKE_YOUNG_PAIR(BGl_string1043z00zzbee_invokez00, BgL_arg1039z00_117); } 
BgL_arg1037z00_115 = 
MAKE_YOUNG_PAIR(BgL_funz00_5, BgL_arg1038z00_116); } 
BgL_list1036z00_114 = 
MAKE_YOUNG_PAIR(BGl_string1044z00zzbee_invokez00, BgL_arg1037z00_115); } 
BgL_cmdz00_42 = 
BGl_stringzd2appendzd2zz__r4_strings_6_7z00(BgL_list1036z00_114); }  else 
{ /* Bee/binvoke.scm 56 */
 obj_t BgL_arg1040z00_118; obj_t BgL_arg1041z00_119;
BgL_arg1040z00_118 = 
CDR(
((obj_t)BgL_cmdz00_103)); 
{ /* Bee/binvoke.scm 57 */
 obj_t BgL_arg1042z00_120;
BgL_arg1042z00_120 = 
CAR(
((obj_t)BgL_cmdz00_103)); 
BgL_arg1041z00_119 = 
string_append_3(BgL_arg1042z00_120, BGl_string1043z00zzbee_invokez00, BgL_resz00_104); } 
{ 
 obj_t BgL_resz00_189; obj_t BgL_cmdz00_188;
BgL_cmdz00_188 = BgL_arg1040z00_118; 
BgL_resz00_189 = BgL_arg1041z00_119; 
BgL_resz00_104 = BgL_resz00_189; 
BgL_cmdz00_103 = BgL_cmdz00_188; 
goto BgL_loopz00_102;} } } } } } 
{ /* Bee/binvoke.scm 59 */
 obj_t BgL_port1014z00_43;
BgL_port1014z00_43 = BGl_za2boutza2z00zzengine_paramz00; 
bgl_display_obj(BgL_cmdz00_42, BgL_port1014z00_43); 
{ /* Bee/binvoke.scm 59 */
 obj_t BgL_tmpz00_191;
BgL_tmpz00_191 = 
((obj_t)BgL_port1014z00_43); 
return 
bgl_display_char(((unsigned char)10), BgL_tmpz00_191);} } } } 

}



/* &bee-notify */
obj_t BGl_z62beezd2notifyzb0zzbee_invokez00(obj_t BgL_envz00_127, obj_t BgL_funz00_128, obj_t BgL_argsz00_129)
{
{ /* Bee/binvoke.scm 46 */
return 
BGl_beezd2notifyzd2zzbee_invokez00(BgL_funz00_128, BgL_argsz00_129);} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zzbee_invokez00(void)
{
{ /* Bee/binvoke.scm 14 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zzbee_invokez00(void)
{
{ /* Bee/binvoke.scm 14 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zzbee_invokez00(void)
{
{ /* Bee/binvoke.scm 14 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzbee_invokez00(void)
{
{ /* Bee/binvoke.scm 14 */
return 
BGl_modulezd2initializa7ationz75zzengine_paramz00(203313037L, 
BSTRING_TO_STRING(BGl_string1048z00zzbee_invokez00));} 

}

#ifdef __cplusplus
}
#endif
