/*===========================================================================*/
/*   (Llib/gstelementfactory.scm)                                            */
/*   Bigloo (4.6a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Jan 27 07:55:05 AM CET 2025     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/bin/bigloo -ldopt -L/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/libbacktrace/usr/lib64/bigloo/4.6a  -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/lib/bigloo/4.6a -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/lib/bigloo/4.6a -unsafe -safee -srfi gstreamer -copt -I/usr/include/gstreamer-1.0 -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -I/usr/include/sysprof-6 -pthread -DWITH_GZFILEOP -copt -fPIC -copt -IClib Llib/gstelementfactory.scm -o objs/gstelementfactory.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* unsafe mode */
#define BIGLOO_UNSAFE 1

/* traces mode */
#define BIGLOO_TRACE 0

/* standard Bigloo include */
#include <bigloo.h>
#include <gst/gst.h>
#include <bglgst_config.h>
#include <bglgst.h>
#include <bglgst_plugin.h>

#ifdef __cplusplus
extern "C" {
#endif
#ifndef BGL_MODULE_TYPE_DEFINITIONS
#define BGL_MODULE_TYPE_DEFINITIONS
#ifndef BGL___GSTREAMER_GSTELEMENTFACTORY_TYPE_DEFINITIONS
#define BGL___GSTREAMER_GSTELEMENTFACTORY_TYPE_DEFINITIONS

/* object type definitions */
typedef struct BgL_z62errorz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
} *BgL_z62errorz62_bglt;

typedef struct BgL_z62exceptionz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_z62exceptionz62_bglt;

typedef struct BgL_z62gstzd2createzd2errorz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
} *BgL_z62gstzd2createzd2errorz62_bglt;

typedef struct BgL_gstzd2objectzd2_bgl {
   header_t header;
   obj_t widening;
   GstObject * BgL_z42builtinz42;
   obj_t BgL_z42finaliza7erze5;
   obj_t BgL_z52closuresz52;
} *BgL_gstzd2objectzd2_bglt;

typedef struct BgL_gstzd2capszd2_bgl {
   header_t header;
   obj_t widening;
   GstCaps * BgL_z42builtinz42;
   obj_t BgL_z42finaliza7erze5;
} *BgL_gstzd2capszd2_bglt;

typedef struct BgL_gstzd2elementzd2_bgl {
   header_t header;
   obj_t widening;
   GstObject * BgL_z42builtinz42;
   obj_t BgL_z42finaliza7erze5;
   obj_t BgL_z52closuresz52;
} *BgL_gstzd2elementzd2_bglt;

typedef struct BgL_gstzd2elementzd2factoryz00_bgl {
   header_t header;
   obj_t widening;
   GstObject * BgL_z42builtinz42;
   obj_t BgL_z42finaliza7erze5;
   obj_t BgL_z52closuresz52;
} *BgL_gstzd2elementzd2factoryz00_bglt;


#endif // BGL___GSTREAMER_GSTELEMENTFACTORY_TYPE_DEFINITIONS
#endif // BGL_MODULE_TYPE_DEFINITIONS

static obj_t BGl_z62zc3z04anonymousza31200ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_gstzd2elementzd2factoryz00zz__gstreamer_gstelementfactoryz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31201ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__gstreamer_gstelementfactoryz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
BGL_EXPORTED_DECL BgL_gstzd2elementzd2_bglt BGl_gstzd2elementzd2factoryzd2makezd2zz__gstreamer_gstelementfactoryz00(obj_t, obj_t);
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31212ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__gstreamer_gstelementfactoryz00(void);
static obj_t BGl_z62zc3z04anonymousza31213ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31205ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__gstreamer_gstelementfactoryz00(void);
extern obj_t BGl_gstzd2pluginzd2featurez00zz__gstreamer_gstpluginfeaturez00;
static obj_t BGl_z62zc3z04anonymousza31206ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__gstreamer_gstelementfactoryz00(void);
static obj_t BGl_z62gstzd2elementzd2factoryzd2haszd2interfacezf3z91zz__gstreamer_gstelementfactoryz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31232ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t);
BGL_EXPORTED_DECL BgL_gstzd2elementzd2_bglt BGl_gstzd2elementzd2factoryzd2createzd2zz__gstreamer_gstelementfactoryz00(BgL_gstzd2elementzd2factoryz00_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza31224ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31217ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static BgL_gstzd2elementzd2_bglt BGl_z62gstzd2elementzd2factoryzd2createzb0zz__gstreamer_gstelementfactoryz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__gstreamer_gstelementfactoryz00(void);
static obj_t BGl_z62zc3z04anonymousza31244ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t);
static obj_t BGl_z62z42makezd2gstzd2elementzd2factoryzf2zz__gstreamer_gstelementfactoryz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31172ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_gstzd2elementzd2factoryzd2canzd2srczd2allzd2capszf3zf3zz__gstreamer_gstelementfactoryz00(BgL_gstzd2elementzd2factoryz00_bglt, BgL_gstzd2capszd2_bglt);
static obj_t BGl_z62zc3z04anonymousza31181ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_gstzd2elementzd2factoryzd2canzd2sinkzd2allzd2capszf3zf3zz__gstreamer_gstelementfactoryz00(BgL_gstzd2elementzd2factoryz00_bglt, BgL_gstzd2capszd2_bglt);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31190ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31271ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31182ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_callzd2virtualzd2setterz00zz__objectz00(BgL_objectz00_bglt, int, obj_t);
extern obj_t BGl_gstzd2objectzd2propertyzd2setz12zc0zz__gstreamer_gstobjectz00(BgL_gstzd2objectzd2_bglt, obj_t, obj_t);
static obj_t BGl_gstzd2elementzd2initz00zz__gstreamer_gstelementfactoryz00(GstElement *, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_gst_element_factory_new(GstElementFactory *, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31354ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t);
static obj_t BGl_z62gstzd2elementzd2factoryzd2canzd2srczd2allzd2capszf3z91zz__gstreamer_gstelementfactoryz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62objectzd2displayzd2gstzd2e1085zb0zz__gstreamer_gstelementfactoryz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__gstreamer_gstelementfactoryz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__gstreamer_gstpadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__gstreamer_gstelementz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__gstreamer_gstpluginfeaturez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_callzd2virtualzd2getterz00zz__objectz00(BgL_objectz00_bglt, int);
static BgL_gstzd2elementzd2factoryz00_bglt BGl_z62lambda1167z62zz__gstreamer_gstelementfactoryz00(obj_t, obj_t, obj_t, obj_t);
static BgL_gstzd2elementzd2factoryz00_bglt BGl_z62lambda1170z62zz__gstreamer_gstelementfactoryz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31195ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t);
extern obj_t BGl_z62gstzd2createzd2errorz62zz__gstreamer_gsterrorz00;
BGL_EXPORTED_DECL bool_t BGl_gstzd2elementzd2factoryzd2haszd2interfacezf3zf3zz__gstreamer_gstelementfactoryz00(BgL_gstzd2elementzd2factoryz00_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza31196ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__gstreamer_gstelementfactoryz00(void);
static obj_t BGl_libraryzd2moduleszd2initz00zz__gstreamer_gstelementfactoryz00(void);
static obj_t BGl_z62gstzd2elementzd2factoryzd2findzb0zz__gstreamer_gstelementfactoryz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__gstreamer_gstelementfactoryz00(void);
static obj_t BGl_gczd2rootszd2initz00zz__gstreamer_gstelementfactoryz00(void);
static obj_t BGl_z62zc3z04anonymousza31189ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t, obj_t);
static BgL_gstzd2elementzd2_bglt BGl_z62gstzd2elementzd2factoryzd2makezb0zz__gstreamer_gstelementfactoryz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
static obj_t BGl_z62gstzd2elementzd2factoryzd2canzd2sinkzd2allzd2capszf3z91zz__gstreamer_gstelementfactoryz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_find_runtime_type(obj_t);
extern obj_t BGl_gstzd2capszd2zz__gstreamer_gstcapsz00;
BGL_EXPORTED_DECL obj_t BGl_gstzd2elementzd2factoryzd2findzd2zz__gstreamer_gstelementfactoryz00(obj_t);
static obj_t __cnst[ 12 ] ;


DEFINE_STRING( BGl_string1400z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1400za700za7za7_1446za7, "bstring", 7 );
DEFINE_STRING( BGl_string1401z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1401za700za7za7_1447za7, "&gst-element-factory-create", 27 );
DEFINE_STRING( BGl_string1402z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1402za700za7za7_1448za7, "gst-element-factory", 19 );
DEFINE_STRING( BGl_string1403z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1403za700za7za7_1449za7, "&gst-element-factory-find", 25 );
DEFINE_STRING( BGl_string1404z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1404za700za7za7_1450za7, "&gst-element-factory-has-interface?", 35 );
DEFINE_STRING( BGl_string1405z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1405za700za7za7_1451za7, "&gst-element-factory-can-sink-all-caps?", 39 );
DEFINE_STRING( BGl_string1406z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1406za700za7za7_1452za7, "gst-caps", 8 );
DEFINE_STRING( BGl_string1407z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1407za700za7za7_1453za7, "&gst-element-factory-can-src-all-caps?", 38 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1408z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1454za7, BGl_z62zc3z04anonymousza31182ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1409z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1455za7, BGl_z62zc3z04anonymousza31181ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1410z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1456za7, BGl_z62zc3z04anonymousza31190ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1411z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1457za7, BGl_z62zc3z04anonymousza31189ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1412z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1458za7, BGl_z62zc3z04anonymousza31196ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1413z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1459za7, BGl_z62zc3z04anonymousza31195ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1414z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1460za7, BGl_z62zc3z04anonymousza31201ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1415z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1461za7, BGl_z62zc3z04anonymousza31200ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1416z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1462za7, BGl_z62zc3z04anonymousza31206ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1417z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1463za7, BGl_z62zc3z04anonymousza31205ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1418z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1464za7, BGl_z62zc3z04anonymousza31213ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1419z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1465za7, BGl_z62zc3z04anonymousza31212ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1420z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1466za7, BGl_z62zc3z04anonymousza31217ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1421z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1467za7, BGl_z62zc3z04anonymousza31224ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1422z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1468za7, BGl_z62zc3z04anonymousza31232ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1423z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1469za7, BGl_z62zc3z04anonymousza31244ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1430z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1430za700za7za7_1470za7, "object-display", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1424z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1471za7, BGl_z62zc3z04anonymousza31271ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1431z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1431za700za7za7_1472za7, "<", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1425z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1473za7, BGl_z62zc3z04anonymousza31354ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1432z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1432za700za7za7_1474za7, " refcount=", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1426z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za7c3za704anonymo1475za7, BGl_z62zc3z04anonymousza31172ze3ze5zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1433z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1433za700za7za7_1476za7, " longname=", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1427z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762lambda1170za7621477z00, BGl_z62lambda1170z62zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string1434z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1434za700za7za7_1478za7, ">", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1428z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762lambda1167za7621479z00, BGl_z62lambda1167z62zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string1435z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1435za700za7za7_1480za7, "__gstreamer_gstelementfactory", 29 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1429z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762objectza7d2disp1481z00, va_generic_entry, BGl_z62objectzd2displayzd2gstzd2e1085zb0zz__gstreamer_gstelementfactoryz00, BUNSPEC, -2 );
DEFINE_STRING( BGl_string1436z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1436za700za7za7_1482za7, "__gstreamer_gstelementfactory gst-element-factory static-pad-templates pair-nil uri-protocols author description klass string longname gst-element-factory-create gst-element-factory-make ", 187 );
DEFINE_STRING( BGl_string1394z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1394za700za7za7_1483za7, "/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/api/gstreamer/src/Llib/gstelementfactory.scm", 96 );
DEFINE_STRING( BGl_string1395z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1395za700za7za7_1484za7, "&$make-gst-element-factory", 26 );
DEFINE_STRING( BGl_string1396z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1396za700za7za7_1485za7, "void*", 5 );
DEFINE_STRING( BGl_string1397z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1397za700za7za7_1486za7, "Cannot create object", 20 );
DEFINE_STRING( BGl_string1398z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1398za700za7za7_1487za7, "Illegal argument", 16 );
DEFINE_STRING( BGl_string1399z00zz__gstreamer_gstelementfactoryz00, BgL_bgl_string1399za700za7za7_1488za7, "&gst-element-factory-make", 25 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_gstzd2elementzd2factoryzd2canzd2srczd2allzd2capszf3zd2envz21zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762gstza7d2element1489z00, BGl_z62gstzd2elementzd2factoryzd2canzd2srczd2allzd2capszf3z91zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_objectzd2displayzd2envz00zz__objectz00;
extern obj_t BGl_z52gstzd2objectzd2initzd2envz80zz__gstreamer_gstobjectz00;
extern obj_t BGl_z52gstzd2objectzd2finaliza7ez12zd2envz35zz__gstreamer_gstobjectz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_gstzd2elementzd2factoryzd2createzd2envz00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762gstza7d2element1490z00, va_generic_entry, BGl_z62gstzd2elementzd2factoryzd2createzb0zz__gstreamer_gstelementfactoryz00, BUNSPEC, -2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_z42makezd2gstzd2elementzd2factoryzd2envz42zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762za742makeza7d2gst1491za7, BGl_z62z42makezd2gstzd2elementzd2factoryzf2zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_gstzd2elementzd2factoryzd2haszd2interfacezf3zd2envz21zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762gstza7d2element1492z00, BGl_z62gstzd2elementzd2factoryzd2haszd2interfacezf3z91zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_gstzd2elementzd2factoryzd2makezd2envz00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762gstza7d2element1493z00, va_generic_entry, BGl_z62gstzd2elementzd2factoryzd2makezb0zz__gstreamer_gstelementfactoryz00, BUNSPEC, -2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_gstzd2elementzd2factoryzd2canzd2sinkzd2allzd2capszf3zd2envz21zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762gstza7d2element1494z00, BGl_z62gstzd2elementzd2factoryzd2canzd2sinkzd2allzd2capszf3z91zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_gstzd2elementzd2factoryzd2findzd2envz00zz__gstreamer_gstelementfactoryz00, BgL_bgl_za762gstza7d2element1495z00, BGl_z62gstzd2elementzd2factoryzd2findzb0zz__gstreamer_gstelementfactoryz00, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_gstzd2elementzd2factoryz00zz__gstreamer_gstelementfactoryz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__gstreamer_gstelementfactoryz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__gstreamer_gstelementfactoryz00(long BgL_checksumz00_553, char * BgL_fromz00_554)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__gstreamer_gstelementfactoryz00))
{ 
BGl_requirezd2initializa7ationz75zz__gstreamer_gstelementfactoryz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__gstreamer_gstelementfactoryz00(); 
BGl_libraryzd2moduleszd2initz00zz__gstreamer_gstelementfactoryz00(); 
BGl_cnstzd2initzd2zz__gstreamer_gstelementfactoryz00(); 
BGl_importedzd2moduleszd2initz00zz__gstreamer_gstelementfactoryz00(); 
BGl_objectzd2initzd2zz__gstreamer_gstelementfactoryz00(); 
BGl_methodzd2initzd2zz__gstreamer_gstelementfactoryz00(); 
return 
BGl_toplevelzd2initzd2zz__gstreamer_gstelementfactoryz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__gstreamer_gstelementfactoryz00(void)
{
{ /* Llib/gstelementfactory.scm 15 */
BGl_modulezd2initializa7ationz75zz__errorz00(0L, "__gstreamer_gstelementfactory"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(0L, "__gstreamer_gstelementfactory"); 
BGl_modulezd2initializa7ationz75zz__objectz00(0L, "__gstreamer_gstelementfactory"); 
BGl_modulezd2initializa7ationz75zz__readerz00(0L, "__gstreamer_gstelementfactory"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(0L, "__gstreamer_gstelementfactory"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(0L, "__gstreamer_gstelementfactory"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(0L, "__gstreamer_gstelementfactory"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(0L, "__gstreamer_gstelementfactory"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__gstreamer_gstelementfactoryz00(void)
{
{ /* Llib/gstelementfactory.scm 15 */
{ /* Llib/gstelementfactory.scm 15 */
 obj_t BgL_cportz00_515;
{ /* Llib/gstelementfactory.scm 15 */
 obj_t BgL_stringz00_522;
BgL_stringz00_522 = BGl_string1436z00zz__gstreamer_gstelementfactoryz00; 
{ /* Llib/gstelementfactory.scm 15 */
 obj_t BgL_startz00_523;
BgL_startz00_523 = 
BINT(0L); 
{ /* Llib/gstelementfactory.scm 15 */
 obj_t BgL_endz00_524;
BgL_endz00_524 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_522))); 
{ /* Llib/gstelementfactory.scm 15 */

BgL_cportz00_515 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_522, BgL_startz00_523, BgL_endz00_524); } } } } 
{ 
 long BgL_iz00_516;
BgL_iz00_516 = 11L; 
BgL_loopz00_517:
if(
(BgL_iz00_516==(-1L)))
{ /* Llib/gstelementfactory.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/gstelementfactory.scm 15 */
{ /* Llib/gstelementfactory.scm 15 */
 obj_t BgL_arg1445z00_518;
{ /* Llib/gstelementfactory.scm 15 */

{ /* Llib/gstelementfactory.scm 15 */
 obj_t BgL_locationz00_520;
BgL_locationz00_520 = 
BBOOL(((bool_t)0)); 
{ /* Llib/gstelementfactory.scm 15 */

BgL_arg1445z00_518 = 
BGl_readz00zz__readerz00(BgL_cportz00_515, BgL_locationz00_520); } } } 
{ /* Llib/gstelementfactory.scm 15 */
 int BgL_tmpz00_582;
BgL_tmpz00_582 = 
(int)(BgL_iz00_516); 
CNST_TABLE_SET(BgL_tmpz00_582, BgL_arg1445z00_518); } } 
{ /* Llib/gstelementfactory.scm 15 */
 int BgL_auxz00_521;
BgL_auxz00_521 = 
(int)(
(BgL_iz00_516-1L)); 
{ 
 long BgL_iz00_587;
BgL_iz00_587 = 
(long)(BgL_auxz00_521); 
BgL_iz00_516 = BgL_iz00_587; 
goto BgL_loopz00_517;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__gstreamer_gstelementfactoryz00(void)
{
{ /* Llib/gstelementfactory.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__gstreamer_gstelementfactoryz00(void)
{
{ /* Llib/gstelementfactory.scm 15 */
return BUNSPEC;} 

}



/* $make-gst-element-factory */
BGL_EXPORTED_DEF obj_t bgl_gst_element_factory_new(GstElementFactory * BgL_factoryz00_3, obj_t BgL_finaliza7erza7_4)
{
{ /* Llib/gstelementfactory.scm 86 */
{ /* Llib/gstelementfactory.scm 87 */
 BgL_gstzd2elementzd2factoryz00_bglt BgL_new1061z00_33;
{ /* Llib/gstelementfactory.scm 88 */
 BgL_gstzd2elementzd2factoryz00_bglt BgL_new1060z00_35;
BgL_new1060z00_35 = 
((BgL_gstzd2elementzd2factoryz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_gstzd2elementzd2factoryz00_bgl) ))); 
{ /* Llib/gstelementfactory.scm 88 */
 long BgL_arg1091z00_36;
BgL_arg1091z00_36 = 
BGL_CLASS_NUM(BGl_gstzd2elementzd2factoryz00zz__gstreamer_gstelementfactoryz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1060z00_35), BgL_arg1091z00_36); } 
BgL_new1061z00_33 = BgL_new1060z00_35; } 
((((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)BgL_new1061z00_33)))->BgL_z42builtinz42)=((GstObject *)
(GstObject *)(BgL_factoryz00_3)),BUNSPEC); 
((((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)BgL_new1061z00_33)))->BgL_z42finaliza7erze5)=((obj_t)BgL_finaliza7erza7_4),BUNSPEC); 
((((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)BgL_new1061z00_33)))->BgL_z52closuresz52)=((obj_t)BNIL),BUNSPEC); 
{ /* Llib/gstelementfactory.scm 87 */
 obj_t BgL_fun1090z00_34;
BgL_fun1090z00_34 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_gstzd2elementzd2factoryz00zz__gstreamer_gstelementfactoryz00); 
BGL_PROCEDURE_CALL1(BgL_fun1090z00_34, 
((obj_t)BgL_new1061z00_33)); } 
return 
((obj_t)BgL_new1061z00_33);} } 

}



/* &$make-gst-element-factory */
obj_t BGl_z62z42makezd2gstzd2elementzd2factoryzf2zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_382, obj_t BgL_factoryz00_383, obj_t BgL_finaliza7erza7_384)
{
{ /* Llib/gstelementfactory.scm 86 */
{ /* Llib/gstelementfactory.scm 87 */
 GstElementFactory * BgL_auxz00_608;
if(
FOREIGNP(BgL_factoryz00_383))
{ /* Llib/gstelementfactory.scm 87 */
BgL_auxz00_608 = 
FOREIGN_TO_COBJ(BgL_factoryz00_383)
; }  else 
{ 
 obj_t BgL_auxz00_612;
BgL_auxz00_612 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1394z00zz__gstreamer_gstelementfactoryz00, 
BINT(3571L), BGl_string1395z00zz__gstreamer_gstelementfactoryz00, BGl_string1396z00zz__gstreamer_gstelementfactoryz00, BgL_factoryz00_383); 
FAILURE(BgL_auxz00_612,BFALSE,BFALSE);} 
return 
bgl_gst_element_factory_new(BgL_auxz00_608, BgL_finaliza7erza7_384);} } 

}



/* gst-element-init */
obj_t BGl_gstzd2elementzd2initz00zz__gstreamer_gstelementfactoryz00(GstElement * BgL_z42elz42_7, obj_t BgL_procz00_8, obj_t BgL_factorynamez00_9, obj_t BgL_namez00_10, obj_t BgL_argsz00_11)
{
{ /* Llib/gstelementfactory.scm 109 */
if(
(bool_t)!(BgL_z42elz42_7))
{ /* Llib/gstelementfactory.scm 115 */
 BgL_z62gstzd2createzd2errorz62_bglt BgL_arg1093z00_38;
{ /* Llib/gstelementfactory.scm 115 */
 BgL_z62gstzd2createzd2errorz62_bglt BgL_new1065z00_39;
{ /* Llib/gstelementfactory.scm 115 */
 BgL_z62gstzd2createzd2errorz62_bglt BgL_new1064z00_43;
BgL_new1064z00_43 = 
((BgL_z62gstzd2createzd2errorz62_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z62gstzd2createzd2errorz62_bgl) ))); 
{ /* Llib/gstelementfactory.scm 115 */
 long BgL_arg1100z00_44;
BgL_arg1100z00_44 = 
BGL_CLASS_NUM(BGl_z62gstzd2createzd2errorz62zz__gstreamer_gsterrorz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1064z00_43), BgL_arg1100z00_44); } 
BgL_new1065z00_39 = BgL_new1064z00_43; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1065z00_39)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1065z00_39)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
 obj_t BgL_auxz00_627;
{ /* Llib/gstelementfactory.scm 115 */
 obj_t BgL_arg1094z00_40;
{ /* Llib/gstelementfactory.scm 115 */
 obj_t BgL_arg1096z00_41;
{ /* Llib/gstelementfactory.scm 115 */
 obj_t BgL_classz00_289;
BgL_classz00_289 = BGl_z62gstzd2createzd2errorz62zz__gstreamer_gsterrorz00; 
BgL_arg1096z00_41 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_289); } 
BgL_arg1094z00_40 = 
VECTOR_REF(BgL_arg1096z00_41,2L); } 
BgL_auxz00_627 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1094z00_40); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1065z00_39)))->BgL_stackz00)=((obj_t)BgL_auxz00_627),BUNSPEC); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1065z00_39)))->BgL_procz00)=((obj_t)BgL_procz00_8),BUNSPEC); 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1065z00_39)))->BgL_msgz00)=((obj_t)BGl_string1397z00zz__gstreamer_gstelementfactoryz00),BUNSPEC); 
{ 
 obj_t BgL_auxz00_637;
{ /* Llib/gstelementfactory.scm 118 */
 obj_t BgL_arg1099z00_42;
BgL_arg1099z00_42 = 
MAKE_YOUNG_PAIR(BgL_namez00_10, BgL_argsz00_11); 
BgL_auxz00_637 = 
MAKE_YOUNG_PAIR(BgL_factorynamez00_9, BgL_arg1099z00_42); } 
((((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_new1065z00_39)))->BgL_objz00)=((obj_t)BgL_auxz00_637),BUNSPEC); } 
BgL_arg1093z00_38 = BgL_new1065z00_39; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1093z00_38));}  else 
{ /* Llib/gstelementfactory.scm 119 */
 obj_t BgL_elz00_45;
{ /* Llib/gstelementfactory.scm 119 */
 GstObject * BgL_arg1118z00_58;
BgL_arg1118z00_58 = 
(GstObject *)(BgL_z42elz42_7); 
BgL_elz00_45 = 
bgl_gst_object_to_obj(BgL_arg1118z00_58, ((bool_t)0)); } 
{ 
 obj_t BgL_argsz00_47;
BgL_argsz00_47 = BgL_argsz00_11; 
BgL_zc3z04anonymousza31101ze3z87_48:
if(
NULLP(BgL_argsz00_47))
{ /* Llib/gstelementfactory.scm 122 */
return BgL_elz00_45;}  else 
{ /* Llib/gstelementfactory.scm 122 */
if(
NULLP(
CDR(
((obj_t)BgL_argsz00_47))))
{ /* Llib/gstelementfactory.scm 125 */
 obj_t BgL_arg1108z00_52;
BgL_arg1108z00_52 = 
CAR(
((obj_t)BgL_argsz00_47)); 
return 
BGl_errorz00zz__errorz00(BgL_procz00_8, BGl_string1398z00zz__gstreamer_gstelementfactoryz00, BgL_arg1108z00_52);}  else 
{ /* Llib/gstelementfactory.scm 124 */
{ /* Llib/gstelementfactory.scm 127 */
 obj_t BgL_arg1109z00_53; obj_t BgL_arg1112z00_54;
BgL_arg1109z00_53 = 
CAR(
((obj_t)BgL_argsz00_47)); 
{ /* Llib/gstelementfactory.scm 127 */
 obj_t BgL_pairz00_297;
BgL_pairz00_297 = 
CDR(
((obj_t)BgL_argsz00_47)); 
BgL_arg1112z00_54 = 
CAR(BgL_pairz00_297); } 
BGl_gstzd2objectzd2propertyzd2setz12zc0zz__gstreamer_gstobjectz00(
((BgL_gstzd2objectzd2_bglt)BgL_elz00_45), BgL_arg1109z00_53, BgL_arg1112z00_54); } 
{ /* Llib/gstelementfactory.scm 128 */
 obj_t BgL_arg1116z00_55;
{ /* Llib/gstelementfactory.scm 128 */
 obj_t BgL_pairz00_301;
BgL_pairz00_301 = 
CDR(
((obj_t)BgL_argsz00_47)); 
BgL_arg1116z00_55 = 
CDR(BgL_pairz00_301); } 
{ 
 obj_t BgL_argsz00_665;
BgL_argsz00_665 = BgL_arg1116z00_55; 
BgL_argsz00_47 = BgL_argsz00_665; 
goto BgL_zc3z04anonymousza31101ze3z87_48;} } } } } } } 

}



/* gst-element-factory-make */
BGL_EXPORTED_DEF BgL_gstzd2elementzd2_bglt BGl_gstzd2elementzd2factoryzd2makezd2zz__gstreamer_gstelementfactoryz00(obj_t BgL_factorynamez00_12, obj_t BgL_az00_13)
{
{ /* Llib/gstelementfactory.scm 133 */
{ /* Llib/gstelementfactory.scm 134 */
 char * BgL_namez00_59; obj_t BgL_restz00_60;
{ /* Llib/gstelementfactory.scm 134 */
 bool_t BgL_test1502z00_666;
if(
PAIRP(BgL_az00_13))
{ /* Llib/gstelementfactory.scm 134 */
 obj_t BgL_tmpz00_669;
BgL_tmpz00_669 = 
CAR(BgL_az00_13); 
BgL_test1502z00_666 = 
STRINGP(BgL_tmpz00_669); }  else 
{ /* Llib/gstelementfactory.scm 134 */
BgL_test1502z00_666 = ((bool_t)0)
; } 
if(BgL_test1502z00_666)
{ /* Llib/gstelementfactory.scm 134 */
BgL_namez00_59 = 
BSTRING_TO_STRING(
CAR(BgL_az00_13)); }  else 
{ /* Llib/gstelementfactory.scm 134 */
BgL_namez00_59 = 
((char *)0L); } } 
{ /* Llib/gstelementfactory.scm 137 */
 bool_t BgL_test1504z00_675;
if(
PAIRP(BgL_az00_13))
{ /* Llib/gstelementfactory.scm 137 */
 obj_t BgL_tmpz00_678;
BgL_tmpz00_678 = 
CAR(BgL_az00_13); 
BgL_test1504z00_675 = 
STRINGP(BgL_tmpz00_678); }  else 
{ /* Llib/gstelementfactory.scm 137 */
BgL_test1504z00_675 = ((bool_t)0)
; } 
if(BgL_test1504z00_675)
{ /* Llib/gstelementfactory.scm 137 */
BgL_restz00_60 = 
CDR(BgL_az00_13); }  else 
{ /* Llib/gstelementfactory.scm 137 */
BgL_restz00_60 = BgL_az00_13; } } 
{ /* Llib/gstelementfactory.scm 138 */
 GstElement * BgL_arg1119z00_61;
{ /* Llib/gstelementfactory.scm 138 */
 char * BgL_tmpz00_682;
BgL_tmpz00_682 = 
BSTRING_TO_STRING(BgL_factorynamez00_12); 
BgL_arg1119z00_61 = 
gst_element_factory_make(BgL_tmpz00_682, BgL_namez00_59); } 
return 
((BgL_gstzd2elementzd2_bglt)
BGl_gstzd2elementzd2initz00zz__gstreamer_gstelementfactoryz00(BgL_arg1119z00_61, 
((obj_t)
CNST_TABLE_REF(0)), BgL_factorynamez00_12, 
string_to_bstring(BgL_namez00_59), BgL_restz00_60));} } } 

}



/* &gst-element-factory-make */
BgL_gstzd2elementzd2_bglt BGl_z62gstzd2elementzd2factoryzd2makezb0zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_385, obj_t BgL_factorynamez00_386, obj_t BgL_az00_387)
{
{ /* Llib/gstelementfactory.scm 133 */
{ /* Llib/gstelementfactory.scm 134 */
 obj_t BgL_auxz00_690;
if(
STRINGP(BgL_factorynamez00_386))
{ /* Llib/gstelementfactory.scm 134 */
BgL_auxz00_690 = BgL_factorynamez00_386
; }  else 
{ 
 obj_t BgL_auxz00_693;
BgL_auxz00_693 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1394z00zz__gstreamer_gstelementfactoryz00, 
BINT(5419L), BGl_string1399z00zz__gstreamer_gstelementfactoryz00, BGl_string1400z00zz__gstreamer_gstelementfactoryz00, BgL_factorynamez00_386); 
FAILURE(BgL_auxz00_693,BFALSE,BFALSE);} 
return 
BGl_gstzd2elementzd2factoryzd2makezd2zz__gstreamer_gstelementfactoryz00(BgL_auxz00_690, BgL_az00_387);} } 

}



/* gst-element-factory-create */
BGL_EXPORTED_DEF BgL_gstzd2elementzd2_bglt BGl_gstzd2elementzd2factoryzd2createzd2zz__gstreamer_gstelementfactoryz00(BgL_gstzd2elementzd2factoryz00_bglt BgL_factoryz00_14, obj_t BgL_az00_15)
{
{ /* Llib/gstelementfactory.scm 147 */
{ /* Llib/gstelementfactory.scm 149 */
 char * BgL_namez00_73;
{ /* Llib/gstelementfactory.scm 149 */
 bool_t BgL_test1507z00_698;
if(
PAIRP(BgL_az00_15))
{ /* Llib/gstelementfactory.scm 149 */
 obj_t BgL_tmpz00_701;
BgL_tmpz00_701 = 
CAR(BgL_az00_15); 
BgL_test1507z00_698 = 
STRINGP(BgL_tmpz00_701); }  else 
{ /* Llib/gstelementfactory.scm 149 */
BgL_test1507z00_698 = ((bool_t)0)
; } 
if(BgL_test1507z00_698)
{ /* Llib/gstelementfactory.scm 149 */
BgL_namez00_73 = 
BSTRING_TO_STRING(
CAR(BgL_az00_15)); }  else 
{ /* Llib/gstelementfactory.scm 149 */
BgL_namez00_73 = 
((char *)0L); } } 
{ /* Llib/gstelementfactory.scm 149 */
 obj_t BgL_restz00_74;
{ /* Llib/gstelementfactory.scm 152 */
 bool_t BgL_test1509z00_707;
if(
PAIRP(BgL_az00_15))
{ /* Llib/gstelementfactory.scm 152 */
 obj_t BgL_tmpz00_710;
BgL_tmpz00_710 = 
CAR(BgL_az00_15); 
BgL_test1509z00_707 = 
STRINGP(BgL_tmpz00_710); }  else 
{ /* Llib/gstelementfactory.scm 152 */
BgL_test1509z00_707 = ((bool_t)0)
; } 
if(BgL_test1509z00_707)
{ /* Llib/gstelementfactory.scm 152 */
BgL_restz00_74 = 
CDR(BgL_az00_15); }  else 
{ /* Llib/gstelementfactory.scm 152 */
BgL_restz00_74 = BgL_az00_15; } } 
{ /* Llib/gstelementfactory.scm 152 */
 GstElement * BgL_z42elz42_75;
{ /* Llib/gstelementfactory.scm 154 */
 GstElementFactory * BgL_arg1133z00_77;
{ /* Llib/gstelementfactory.scm 154 */
 GstObject * BgL_arg1136z00_78;
BgL_arg1136z00_78 = 
(((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)BgL_factoryz00_14)))->BgL_z42builtinz42); 
BgL_arg1133z00_77 = 
GST_ELEMENT_FACTORY(BgL_arg1136z00_78); } 
BgL_z42elz42_75 = 
gst_element_factory_create(BgL_arg1133z00_77, BgL_namez00_73); } 
{ /* Llib/gstelementfactory.scm 153 */

{ /* Llib/gstelementfactory.scm 157 */
 obj_t BgL_arg1132z00_76;
BgL_arg1132z00_76 = 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_factoryz00_14), 
(int)(0L)); 
return 
((BgL_gstzd2elementzd2_bglt)
BGl_gstzd2elementzd2initz00zz__gstreamer_gstelementfactoryz00(BgL_z42elz42_75, 
((obj_t)
CNST_TABLE_REF(1)), BgL_arg1132z00_76, 
string_to_bstring(BgL_namez00_73), BgL_restz00_74));} } } } } } 

}



/* &gst-element-factory-create */
BgL_gstzd2elementzd2_bglt BGl_z62gstzd2elementzd2factoryzd2createzb0zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_388, obj_t BgL_factoryz00_389, obj_t BgL_az00_390)
{
{ /* Llib/gstelementfactory.scm 147 */
{ /* Llib/gstelementfactory.scm 148 */
 BgL_gstzd2elementzd2factoryz00_bglt BgL_auxz00_726;
if(
BGl_isazf3zf3zz__objectz00(BgL_factoryz00_389, BGl_gstzd2elementzd2factoryz00zz__gstreamer_gstelementfactoryz00))
{ /* Llib/gstelementfactory.scm 148 */
BgL_auxz00_726 = 
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_factoryz00_389)
; }  else 
{ 
 obj_t BgL_auxz00_730;
BgL_auxz00_730 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1394z00zz__gstreamer_gstelementfactoryz00, 
BINT(5998L), BGl_string1401z00zz__gstreamer_gstelementfactoryz00, BGl_string1402z00zz__gstreamer_gstelementfactoryz00, BgL_factoryz00_389); 
FAILURE(BgL_auxz00_730,BFALSE,BFALSE);} 
return 
BGl_gstzd2elementzd2factoryzd2createzd2zz__gstreamer_gstelementfactoryz00(BgL_auxz00_726, BgL_az00_390);} } 

}



/* gst-element-factory-find */
BGL_EXPORTED_DEF obj_t BGl_gstzd2elementzd2factoryzd2findzd2zz__gstreamer_gstelementfactoryz00(obj_t BgL_namez00_16)
{
{ /* Llib/gstelementfactory.scm 162 */
{ /* Llib/gstelementfactory.scm 163 */
 GstElementFactory * BgL_efz00_89;
{ /* Llib/gstelementfactory.scm 163 */
 char * BgL_tmpz00_735;
BgL_tmpz00_735 = 
BSTRING_TO_STRING(BgL_namez00_16); 
BgL_efz00_89 = 
gst_element_factory_find(BgL_tmpz00_735); } 
if(
(bool_t)!(BgL_efz00_89))
{ /* Llib/gstelementfactory.scm 164 */
return BFALSE;}  else 
{ /* Llib/gstelementfactory.scm 165 */
 BgL_gstzd2elementzd2factoryz00_bglt BgL_new1068z00_91;
{ /* Llib/gstelementfactory.scm 166 */
 BgL_gstzd2elementzd2factoryz00_bglt BgL_new1067z00_93;
BgL_new1067z00_93 = 
((BgL_gstzd2elementzd2factoryz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_gstzd2elementzd2factoryz00_bgl) ))); 
{ /* Llib/gstelementfactory.scm 166 */
 long BgL_arg1147z00_94;
BgL_arg1147z00_94 = 
BGL_CLASS_NUM(BGl_gstzd2elementzd2factoryz00zz__gstreamer_gstelementfactoryz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1067z00_93), BgL_arg1147z00_94); } 
BgL_new1068z00_91 = BgL_new1067z00_93; } 
((((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)BgL_new1068z00_91)))->BgL_z42builtinz42)=((GstObject *)
(GstObject *)(BgL_efz00_89)),BUNSPEC); 
((((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)BgL_new1068z00_91)))->BgL_z42finaliza7erze5)=((obj_t)BGl_z52gstzd2objectzd2finaliza7ez12zd2envz35zz__gstreamer_gstobjectz00),BUNSPEC); 
((((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)BgL_new1068z00_91)))->BgL_z52closuresz52)=((obj_t)BNIL),BUNSPEC); 
{ /* Llib/gstelementfactory.scm 165 */
 obj_t BgL_fun1146z00_92;
BgL_fun1146z00_92 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_gstzd2elementzd2factoryz00zz__gstreamer_gstelementfactoryz00); 
BGL_PROCEDURE_CALL1(BgL_fun1146z00_92, 
((obj_t)BgL_new1068z00_91)); } 
return 
((obj_t)BgL_new1068z00_91);} } } 

}



/* &gst-element-factory-find */
obj_t BGl_z62gstzd2elementzd2factoryzd2findzb0zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_391, obj_t BgL_namez00_392)
{
{ /* Llib/gstelementfactory.scm 162 */
{ /* Llib/gstelementfactory.scm 163 */
 obj_t BgL_auxz00_758;
if(
STRINGP(BgL_namez00_392))
{ /* Llib/gstelementfactory.scm 163 */
BgL_auxz00_758 = BgL_namez00_392
; }  else 
{ 
 obj_t BgL_auxz00_761;
BgL_auxz00_761 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1394z00zz__gstreamer_gstelementfactoryz00, 
BINT(6709L), BGl_string1403z00zz__gstreamer_gstelementfactoryz00, BGl_string1400z00zz__gstreamer_gstelementfactoryz00, BgL_namez00_392); 
FAILURE(BgL_auxz00_761,BFALSE,BFALSE);} 
return 
BGl_gstzd2elementzd2factoryzd2findzd2zz__gstreamer_gstelementfactoryz00(BgL_auxz00_758);} } 

}



/* gst-element-factory-has-interface? */
BGL_EXPORTED_DEF bool_t BGl_gstzd2elementzd2factoryzd2haszd2interfacezf3zf3zz__gstreamer_gstelementfactoryz00(BgL_gstzd2elementzd2factoryz00_bglt BgL_factoryz00_17, obj_t BgL_namez00_18)
{
{ /* Llib/gstelementfactory.scm 172 */
{ /* Llib/gstelementfactory.scm 175 */
 GstElementFactory * BgL_arg1148z00_314;
{ /* Llib/gstelementfactory.scm 175 */
 GstObject * BgL_arg1149z00_315;
BgL_arg1149z00_315 = 
(((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)BgL_factoryz00_17)))->BgL_z42builtinz42); 
BgL_arg1148z00_314 = 
GST_ELEMENT_FACTORY(BgL_arg1149z00_315); } 
{ /* Llib/gstelementfactory.scm 174 */
 char * BgL_tmpz00_769;
BgL_tmpz00_769 = 
BSTRING_TO_STRING(BgL_namez00_18); 
return 
gst_element_factory_has_interface(BgL_arg1148z00_314, BgL_tmpz00_769);} } } 

}



/* &gst-element-factory-has-interface? */
obj_t BGl_z62gstzd2elementzd2factoryzd2haszd2interfacezf3z91zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_395, obj_t BgL_factoryz00_396, obj_t BgL_namez00_397)
{
{ /* Llib/gstelementfactory.scm 172 */
{ /* Llib/gstelementfactory.scm 173 */
 bool_t BgL_tmpz00_772;
{ /* Llib/gstelementfactory.scm 173 */
 obj_t BgL_auxz00_781; BgL_gstzd2elementzd2factoryz00_bglt BgL_auxz00_773;
if(
STRINGP(BgL_namez00_397))
{ /* Llib/gstelementfactory.scm 173 */
BgL_auxz00_781 = BgL_namez00_397
; }  else 
{ 
 obj_t BgL_auxz00_784;
BgL_auxz00_784 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1394z00zz__gstreamer_gstelementfactoryz00, 
BINT(7236L), BGl_string1404z00zz__gstreamer_gstelementfactoryz00, BGl_string1400z00zz__gstreamer_gstelementfactoryz00, BgL_namez00_397); 
FAILURE(BgL_auxz00_784,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_factoryz00_396, BGl_gstzd2elementzd2factoryz00zz__gstreamer_gstelementfactoryz00))
{ /* Llib/gstelementfactory.scm 173 */
BgL_auxz00_773 = 
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_factoryz00_396)
; }  else 
{ 
 obj_t BgL_auxz00_777;
BgL_auxz00_777 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1394z00zz__gstreamer_gstelementfactoryz00, 
BINT(7236L), BGl_string1404z00zz__gstreamer_gstelementfactoryz00, BGl_string1402z00zz__gstreamer_gstelementfactoryz00, BgL_factoryz00_396); 
FAILURE(BgL_auxz00_777,BFALSE,BFALSE);} 
BgL_tmpz00_772 = 
BGl_gstzd2elementzd2factoryzd2haszd2interfacezf3zf3zz__gstreamer_gstelementfactoryz00(BgL_auxz00_773, BgL_auxz00_781); } 
return 
BBOOL(BgL_tmpz00_772);} } 

}



/* gst-element-factory-can-sink-all-caps? */
BGL_EXPORTED_DEF bool_t BGl_gstzd2elementzd2factoryzd2canzd2sinkzd2allzd2capszf3zf3zz__gstreamer_gstelementfactoryz00(BgL_gstzd2elementzd2factoryz00_bglt BgL_factoryz00_19, BgL_gstzd2capszd2_bglt BgL_capsz00_20)
{
{ /* Llib/gstelementfactory.scm 181 */
{ /* Llib/gstelementfactory.scm 185 */
 GstElementFactory * BgL_arg1150z00_318; GstCaps * BgL_arg1151z00_319;
{ /* Llib/gstelementfactory.scm 185 */
 GstObject * BgL_arg1152z00_320;
BgL_arg1152z00_320 = 
(((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)BgL_factoryz00_19)))->BgL_z42builtinz42); 
BgL_arg1150z00_318 = 
GST_ELEMENT_FACTORY(BgL_arg1152z00_320); } 
BgL_arg1151z00_319 = 
(((BgL_gstzd2capszd2_bglt)COBJECT(BgL_capsz00_20))->BgL_z42builtinz42); 
return 
gst_element_factory_can_sink_all_caps(BgL_arg1150z00_318, BgL_arg1151z00_319);} } 

}



/* &gst-element-factory-can-sink-all-caps? */
obj_t BGl_z62gstzd2elementzd2factoryzd2canzd2sinkzd2allzd2capszf3z91zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_398, obj_t BgL_factoryz00_399, obj_t BgL_capsz00_400)
{
{ /* Llib/gstelementfactory.scm 181 */
{ /* Llib/gstelementfactory.scm 182 */
 bool_t BgL_tmpz00_795;
{ /* Llib/gstelementfactory.scm 182 */
 BgL_gstzd2capszd2_bglt BgL_auxz00_804; BgL_gstzd2elementzd2factoryz00_bglt BgL_auxz00_796;
if(
BGl_isazf3zf3zz__objectz00(BgL_capsz00_400, BGl_gstzd2capszd2zz__gstreamer_gstcapsz00))
{ /* Llib/gstelementfactory.scm 182 */
BgL_auxz00_804 = 
((BgL_gstzd2capszd2_bglt)BgL_capsz00_400)
; }  else 
{ 
 obj_t BgL_auxz00_808;
BgL_auxz00_808 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1394z00zz__gstreamer_gstelementfactoryz00, 
BINT(7664L), BGl_string1405z00zz__gstreamer_gstelementfactoryz00, BGl_string1406z00zz__gstreamer_gstelementfactoryz00, BgL_capsz00_400); 
FAILURE(BgL_auxz00_808,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_factoryz00_399, BGl_gstzd2elementzd2factoryz00zz__gstreamer_gstelementfactoryz00))
{ /* Llib/gstelementfactory.scm 182 */
BgL_auxz00_796 = 
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_factoryz00_399)
; }  else 
{ 
 obj_t BgL_auxz00_800;
BgL_auxz00_800 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1394z00zz__gstreamer_gstelementfactoryz00, 
BINT(7664L), BGl_string1405z00zz__gstreamer_gstelementfactoryz00, BGl_string1402z00zz__gstreamer_gstelementfactoryz00, BgL_factoryz00_399); 
FAILURE(BgL_auxz00_800,BFALSE,BFALSE);} 
BgL_tmpz00_795 = 
BGl_gstzd2elementzd2factoryzd2canzd2sinkzd2allzd2capszf3zf3zz__gstreamer_gstelementfactoryz00(BgL_auxz00_796, BgL_auxz00_804); } 
return 
BBOOL(BgL_tmpz00_795);} } 

}



/* gst-element-factory-can-src-all-caps? */
BGL_EXPORTED_DEF bool_t BGl_gstzd2elementzd2factoryzd2canzd2srczd2allzd2capszf3zf3zz__gstreamer_gstelementfactoryz00(BgL_gstzd2elementzd2factoryz00_bglt BgL_factoryz00_21, BgL_gstzd2capszd2_bglt BgL_capsz00_22)
{
{ /* Llib/gstelementfactory.scm 191 */
{ /* Llib/gstelementfactory.scm 195 */
 GstElementFactory * BgL_arg1154z00_323; GstCaps * BgL_arg1155z00_324;
{ /* Llib/gstelementfactory.scm 195 */
 GstObject * BgL_arg1160z00_325;
BgL_arg1160z00_325 = 
(((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)BgL_factoryz00_21)))->BgL_z42builtinz42); 
BgL_arg1154z00_323 = 
GST_ELEMENT_FACTORY(BgL_arg1160z00_325); } 
BgL_arg1155z00_324 = 
(((BgL_gstzd2capszd2_bglt)COBJECT(BgL_capsz00_22))->BgL_z42builtinz42); 
return 
gst_element_factory_can_src_all_caps(BgL_arg1154z00_323, BgL_arg1155z00_324);} } 

}



/* &gst-element-factory-can-src-all-caps? */
obj_t BGl_z62gstzd2elementzd2factoryzd2canzd2srczd2allzd2capszf3z91zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_401, obj_t BgL_factoryz00_402, obj_t BgL_capsz00_403)
{
{ /* Llib/gstelementfactory.scm 191 */
{ /* Llib/gstelementfactory.scm 192 */
 bool_t BgL_tmpz00_819;
{ /* Llib/gstelementfactory.scm 192 */
 BgL_gstzd2capszd2_bglt BgL_auxz00_828; BgL_gstzd2elementzd2factoryz00_bglt BgL_auxz00_820;
if(
BGl_isazf3zf3zz__objectz00(BgL_capsz00_403, BGl_gstzd2capszd2zz__gstreamer_gstcapsz00))
{ /* Llib/gstelementfactory.scm 192 */
BgL_auxz00_828 = 
((BgL_gstzd2capszd2_bglt)BgL_capsz00_403)
; }  else 
{ 
 obj_t BgL_auxz00_832;
BgL_auxz00_832 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1394z00zz__gstreamer_gstelementfactoryz00, 
BINT(8166L), BGl_string1407z00zz__gstreamer_gstelementfactoryz00, BGl_string1406z00zz__gstreamer_gstelementfactoryz00, BgL_capsz00_403); 
FAILURE(BgL_auxz00_832,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_factoryz00_402, BGl_gstzd2elementzd2factoryz00zz__gstreamer_gstelementfactoryz00))
{ /* Llib/gstelementfactory.scm 192 */
BgL_auxz00_820 = 
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_factoryz00_402)
; }  else 
{ 
 obj_t BgL_auxz00_824;
BgL_auxz00_824 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1394z00zz__gstreamer_gstelementfactoryz00, 
BINT(8166L), BGl_string1407z00zz__gstreamer_gstelementfactoryz00, BGl_string1402z00zz__gstreamer_gstelementfactoryz00, BgL_factoryz00_402); 
FAILURE(BgL_auxz00_824,BFALSE,BFALSE);} 
BgL_tmpz00_819 = 
BGl_gstzd2elementzd2factoryzd2canzd2srczd2allzd2capszf3zf3zz__gstreamer_gstelementfactoryz00(BgL_auxz00_820, BgL_auxz00_828); } 
return 
BBOOL(BgL_tmpz00_819);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__gstreamer_gstelementfactoryz00(void)
{
{ /* Llib/gstelementfactory.scm 15 */
{ /* Llib/gstelementfactory.scm 28 */
 obj_t BgL_arg1165z00_111; obj_t BgL_arg1166z00_112;
{ /* Llib/gstelementfactory.scm 28 */
 obj_t BgL_v1082z00_126;
BgL_v1082z00_126 = 
create_vector(6L); 
{ /* Llib/gstelementfactory.scm 28 */
 obj_t BgL_arg1175z00_127;
BgL_arg1175z00_127 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
((obj_t)
CNST_TABLE_REF(2)), BGl_proc1409z00zz__gstreamer_gstelementfactoryz00, BGl_proc1408z00zz__gstreamer_gstelementfactoryz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
((obj_t)
CNST_TABLE_REF(3))); 
VECTOR_SET(BgL_v1082z00_126,0L,BgL_arg1175z00_127); } 
{ /* Llib/gstelementfactory.scm 28 */
 obj_t BgL_arg1185z00_137;
BgL_arg1185z00_137 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
((obj_t)
CNST_TABLE_REF(4)), BGl_proc1411z00zz__gstreamer_gstelementfactoryz00, BGl_proc1410z00zz__gstreamer_gstelementfactoryz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
((obj_t)
CNST_TABLE_REF(3))); 
VECTOR_SET(BgL_v1082z00_126,1L,BgL_arg1185z00_137); } 
{ /* Llib/gstelementfactory.scm 28 */
 obj_t BgL_arg1191z00_147;
BgL_arg1191z00_147 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
((obj_t)
CNST_TABLE_REF(5)), BGl_proc1413z00zz__gstreamer_gstelementfactoryz00, BGl_proc1412z00zz__gstreamer_gstelementfactoryz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
((obj_t)
CNST_TABLE_REF(3))); 
VECTOR_SET(BgL_v1082z00_126,2L,BgL_arg1191z00_147); } 
{ /* Llib/gstelementfactory.scm 28 */
 obj_t BgL_arg1197z00_157;
BgL_arg1197z00_157 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
((obj_t)
CNST_TABLE_REF(6)), BGl_proc1415z00zz__gstreamer_gstelementfactoryz00, BGl_proc1414z00zz__gstreamer_gstelementfactoryz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
((obj_t)
CNST_TABLE_REF(3))); 
VECTOR_SET(BgL_v1082z00_126,3L,BgL_arg1197z00_157); } 
{ /* Llib/gstelementfactory.scm 28 */
 obj_t BgL_arg1202z00_167;
BgL_arg1202z00_167 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
((obj_t)
CNST_TABLE_REF(7)), BGl_proc1417z00zz__gstreamer_gstelementfactoryz00, BGl_proc1416z00zz__gstreamer_gstelementfactoryz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
((obj_t)
CNST_TABLE_REF(8))); 
VECTOR_SET(BgL_v1082z00_126,4L,BgL_arg1202z00_167); } 
{ /* Llib/gstelementfactory.scm 28 */
 obj_t BgL_arg1209z00_177;
BgL_arg1209z00_177 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
((obj_t)
CNST_TABLE_REF(9)), BGl_proc1419z00zz__gstreamer_gstelementfactoryz00, BGl_proc1418z00zz__gstreamer_gstelementfactoryz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
((obj_t)
CNST_TABLE_REF(8))); 
VECTOR_SET(BgL_v1082z00_126,5L,BgL_arg1209z00_177); } 
BgL_arg1165z00_111 = BgL_v1082z00_126; } 
{ /* Llib/gstelementfactory.scm 28 */
 obj_t BgL_v1083z00_187;
BgL_v1083z00_187 = 
create_vector(6L); 
{ /* Llib/gstelementfactory.scm 32 */
 obj_t BgL_arg1214z00_188;
{ /* Llib/gstelementfactory.scm 32 */
 obj_t BgL_arg1215z00_189;
BgL_arg1215z00_189 = 
MAKE_YOUNG_PAIR(BGl_proc1420z00zz__gstreamer_gstelementfactoryz00, BFALSE); 
BgL_arg1214z00_188 = 
MAKE_YOUNG_PAIR(
BINT(3L), BgL_arg1215z00_189); } 
VECTOR_SET(BgL_v1083z00_187,0L,BgL_arg1214z00_188); } 
{ /* Llib/gstelementfactory.scm 39 */
 obj_t BgL_arg1221z00_201;
{ /* Llib/gstelementfactory.scm 39 */
 obj_t BgL_arg1222z00_202;
BgL_arg1222z00_202 = 
MAKE_YOUNG_PAIR(BGl_proc1421z00zz__gstreamer_gstelementfactoryz00, BFALSE); 
BgL_arg1221z00_201 = 
MAKE_YOUNG_PAIR(
BINT(4L), BgL_arg1222z00_202); } 
VECTOR_SET(BgL_v1083z00_187,1L,BgL_arg1221z00_201); } 
{ /* Llib/gstelementfactory.scm 46 */
 obj_t BgL_arg1229z00_214;
{ /* Llib/gstelementfactory.scm 46 */
 obj_t BgL_arg1230z00_215;
BgL_arg1230z00_215 = 
MAKE_YOUNG_PAIR(BGl_proc1422z00zz__gstreamer_gstelementfactoryz00, BFALSE); 
BgL_arg1229z00_214 = 
MAKE_YOUNG_PAIR(
BINT(5L), BgL_arg1230z00_215); } 
VECTOR_SET(BgL_v1083z00_187,2L,BgL_arg1229z00_214); } 
{ /* Llib/gstelementfactory.scm 53 */
 obj_t BgL_arg1238z00_227;
{ /* Llib/gstelementfactory.scm 53 */
 obj_t BgL_arg1239z00_228;
BgL_arg1239z00_228 = 
MAKE_YOUNG_PAIR(BGl_proc1423z00zz__gstreamer_gstelementfactoryz00, BFALSE); 
BgL_arg1238z00_227 = 
MAKE_YOUNG_PAIR(
BINT(6L), BgL_arg1239z00_228); } 
VECTOR_SET(BgL_v1083z00_187,3L,BgL_arg1238z00_227); } 
{ /* Llib/gstelementfactory.scm 60 */
 obj_t BgL_arg1265z00_240;
{ /* Llib/gstelementfactory.scm 60 */
 obj_t BgL_arg1269z00_241;
BgL_arg1269z00_241 = 
MAKE_YOUNG_PAIR(BGl_proc1424z00zz__gstreamer_gstelementfactoryz00, BFALSE); 
BgL_arg1265z00_240 = 
MAKE_YOUNG_PAIR(
BINT(7L), BgL_arg1269z00_241); } 
VECTOR_SET(BgL_v1083z00_187,4L,BgL_arg1265z00_240); } 
{ /* Llib/gstelementfactory.scm 67 */
 obj_t BgL_arg1325z00_253;
{ /* Llib/gstelementfactory.scm 67 */
 obj_t BgL_arg1337z00_254;
BgL_arg1337z00_254 = 
MAKE_YOUNG_PAIR(BGl_proc1425z00zz__gstreamer_gstelementfactoryz00, BFALSE); 
BgL_arg1325z00_253 = 
MAKE_YOUNG_PAIR(
BINT(8L), BgL_arg1337z00_254); } 
VECTOR_SET(BgL_v1083z00_187,5L,BgL_arg1325z00_253); } 
BgL_arg1166z00_112 = BgL_v1083z00_187; } 
return ( 
BGl_gstzd2elementzd2factoryz00zz__gstreamer_gstelementfactoryz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
((obj_t)
CNST_TABLE_REF(10)), 
((obj_t)
CNST_TABLE_REF(11)), BGl_gstzd2pluginzd2featurez00zz__gstreamer_gstpluginfeaturez00, 19357L, BGl_proc1428z00zz__gstreamer_gstelementfactoryz00, BGl_proc1427z00zz__gstreamer_gstelementfactoryz00, BGl_z52gstzd2objectzd2initzd2envz80zz__gstreamer_gstobjectz00, BGl_proc1426z00zz__gstreamer_gstelementfactoryz00, BFALSE, BgL_arg1165z00_111, BgL_arg1166z00_112), BUNSPEC) ;} } 

}



/* &<@anonymous:1172> */
obj_t BGl_z62zc3z04anonymousza31172ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_425, obj_t BgL_new1059z00_426)
{
{ /* Llib/gstelementfactory.scm 28 */
{ 
 BgL_gstzd2elementzd2factoryz00_bglt BgL_auxz00_905;
((((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_new1059z00_426))))->BgL_z42builtinz42)=((GstObject *)
0L),BUNSPEC); 
((((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_new1059z00_426))))->BgL_z42finaliza7erze5)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_new1059z00_426))))->BgL_z52closuresz52)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_905 = 
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_new1059z00_426); 
return 
((obj_t)BgL_auxz00_905);} } 

}



/* &lambda1170 */
BgL_gstzd2elementzd2factoryz00_bglt BGl_z62lambda1170z62zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_427)
{
{ /* Llib/gstelementfactory.scm 28 */
{ /* Llib/gstelementfactory.scm 28 */
 BgL_gstzd2elementzd2factoryz00_bglt BgL_new1058z00_527;
BgL_new1058z00_527 = 
((BgL_gstzd2elementzd2factoryz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_gstzd2elementzd2factoryz00_bgl) ))); 
{ /* Llib/gstelementfactory.scm 28 */
 long BgL_arg1171z00_528;
BgL_arg1171z00_528 = 
BGL_CLASS_NUM(BGl_gstzd2elementzd2factoryz00zz__gstreamer_gstelementfactoryz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1058z00_527), BgL_arg1171z00_528); } 
return BgL_new1058z00_527;} } 

}



/* &lambda1167 */
BgL_gstzd2elementzd2factoryz00_bglt BGl_z62lambda1167z62zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_428, obj_t BgL_z42builtin1055z42_429, obj_t BgL_z42finaliza7er1056ze5_430, obj_t BgL_z52closures1057z52_431)
{
{ /* Llib/gstelementfactory.scm 28 */
{ /* Llib/gstelementfactory.scm 28 */
 GstObject * BgL_z42builtin1055z42_529;
BgL_z42builtin1055z42_529 = 
FOREIGN_TO_COBJ(BgL_z42builtin1055z42_429); 
{ /* Llib/gstelementfactory.scm 28 */
 BgL_gstzd2elementzd2factoryz00_bglt BgL_new1075z00_531;
{ /* Llib/gstelementfactory.scm 28 */
 BgL_gstzd2elementzd2factoryz00_bglt BgL_new1074z00_532;
BgL_new1074z00_532 = 
((BgL_gstzd2elementzd2factoryz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_gstzd2elementzd2factoryz00_bgl) ))); 
{ /* Llib/gstelementfactory.scm 28 */
 long BgL_arg1169z00_533;
BgL_arg1169z00_533 = 
BGL_CLASS_NUM(BGl_gstzd2elementzd2factoryz00zz__gstreamer_gstelementfactoryz00); 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1074z00_532), BgL_arg1169z00_533); } 
BgL_new1075z00_531 = BgL_new1074z00_532; } 
((((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)BgL_new1075z00_531)))->BgL_z42builtinz42)=((GstObject *)BgL_z42builtin1055z42_529),BUNSPEC); 
((((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)BgL_new1075z00_531)))->BgL_z42finaliza7erze5)=((obj_t)BgL_z42finaliza7er1056ze5_430),BUNSPEC); 
((((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)BgL_new1075z00_531)))->BgL_z52closuresz52)=((obj_t)
((obj_t)BgL_z52closures1057z52_431)),BUNSPEC); 
{ /* Llib/gstelementfactory.scm 28 */
 obj_t BgL_fun1168z00_534;
BgL_fun1168z00_534 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_gstzd2elementzd2factoryz00zz__gstreamer_gstelementfactoryz00); 
BGL_PROCEDURE_CALL1(BgL_fun1168z00_534, 
((obj_t)BgL_new1075z00_531)); } 
return BgL_new1075z00_531;} } } 

}



/* &<@anonymous:1354> */
obj_t BGl_z62zc3z04anonymousza31354ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_432, obj_t BgL_oz00_433)
{
{ /* Llib/gstelementfactory.scm 64 */
{ /* Llib/gstelementfactory.scm 69 */
 GstElementFactory * BgL_arg1355z00_535;
{ /* Llib/gstelementfactory.scm 69 */
 GstObject * BgL_arg1356z00_536;
BgL_arg1356z00_536 = 
(((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_oz00_433))))->BgL_z42builtinz42); 
BgL_arg1355z00_535 = 
GST_ELEMENT_FACTORY(BgL_arg1356z00_536); } 
return 
bgl_gst_element_factory_get_static_pad_templates(BgL_arg1355z00_535);} } 

}



/* &<@anonymous:1271> */
obj_t BGl_z62zc3z04anonymousza31271ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_434, obj_t BgL_oz00_435)
{
{ /* Llib/gstelementfactory.scm 57 */
{ /* Llib/gstelementfactory.scm 62 */
 GstElementFactory * BgL_arg1278z00_537;
{ /* Llib/gstelementfactory.scm 62 */
 GstObject * BgL_arg1286z00_538;
BgL_arg1286z00_538 = 
(((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_oz00_435))))->BgL_z42builtinz42); 
BgL_arg1278z00_537 = 
GST_ELEMENT_FACTORY(BgL_arg1286z00_538); } 
return 
bgl_gst_element_factory_get_uri_protocols(BgL_arg1278z00_537);} } 

}



/* &<@anonymous:1244> */
obj_t BGl_z62zc3z04anonymousza31244ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_436, obj_t BgL_oz00_437)
{
{ /* Llib/gstelementfactory.scm 50 */
{ /* Llib/gstelementfactory.scm 53 */
 char * BgL_tmpz00_950;
{ /* Llib/gstelementfactory.scm 55 */
 GstElementFactory * BgL_arg1248z00_539;
{ /* Llib/gstelementfactory.scm 55 */
 GstObject * BgL_arg1263z00_540;
BgL_arg1263z00_540 = 
(((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_oz00_437))))->BgL_z42builtinz42); 
BgL_arg1248z00_539 = 
GST_ELEMENT_FACTORY(BgL_arg1263z00_540); } 
BgL_tmpz00_950 = 
(char *)gst_element_factory_get_metadata(BgL_arg1248z00_539, GST_ELEMENT_METADATA_AUTHOR); } 
return 
string_to_bstring(BgL_tmpz00_950);} } 

}



/* &<@anonymous:1232> */
obj_t BGl_z62zc3z04anonymousza31232ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_438, obj_t BgL_oz00_439)
{
{ /* Llib/gstelementfactory.scm 43 */
{ /* Llib/gstelementfactory.scm 46 */
 char * BgL_tmpz00_957;
{ /* Llib/gstelementfactory.scm 48 */
 GstElementFactory * BgL_arg1233z00_541;
{ /* Llib/gstelementfactory.scm 48 */
 GstObject * BgL_arg1234z00_542;
BgL_arg1234z00_542 = 
(((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_oz00_439))))->BgL_z42builtinz42); 
BgL_arg1233z00_541 = 
GST_ELEMENT_FACTORY(BgL_arg1234z00_542); } 
BgL_tmpz00_957 = 
(char *)gst_element_factory_get_metadata(BgL_arg1233z00_541, GST_ELEMENT_METADATA_DESCRIPTION); } 
return 
string_to_bstring(BgL_tmpz00_957);} } 

}



/* &<@anonymous:1224> */
obj_t BGl_z62zc3z04anonymousza31224ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_440, obj_t BgL_oz00_441)
{
{ /* Llib/gstelementfactory.scm 36 */
{ /* Llib/gstelementfactory.scm 39 */
 char * BgL_tmpz00_964;
{ /* Llib/gstelementfactory.scm 41 */
 GstElementFactory * BgL_arg1225z00_543;
{ /* Llib/gstelementfactory.scm 41 */
 GstObject * BgL_arg1227z00_544;
BgL_arg1227z00_544 = 
(((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_oz00_441))))->BgL_z42builtinz42); 
BgL_arg1225z00_543 = 
GST_ELEMENT_FACTORY(BgL_arg1227z00_544); } 
BgL_tmpz00_964 = 
(char *)gst_element_factory_get_metadata(BgL_arg1225z00_543, GST_ELEMENT_METADATA_KLASS); } 
return 
string_to_bstring(BgL_tmpz00_964);} } 

}



/* &<@anonymous:1217> */
obj_t BGl_z62zc3z04anonymousza31217ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_442, obj_t BgL_oz00_443)
{
{ /* Llib/gstelementfactory.scm 29 */
{ /* Llib/gstelementfactory.scm 32 */
 char * BgL_tmpz00_971;
{ /* Llib/gstelementfactory.scm 34 */
 GstElementFactory * BgL_arg1218z00_545;
{ /* Llib/gstelementfactory.scm 34 */
 GstObject * BgL_arg1219z00_546;
BgL_arg1219z00_546 = 
(((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_oz00_443))))->BgL_z42builtinz42); 
BgL_arg1218z00_545 = 
GST_ELEMENT_FACTORY(BgL_arg1219z00_546); } 
BgL_tmpz00_971 = 
(char *)gst_element_factory_get_metadata(BgL_arg1218z00_545, GST_ELEMENT_METADATA_LONGNAME); } 
return 
string_to_bstring(BgL_tmpz00_971);} } 

}



/* &<@anonymous:1213> */
obj_t BGl_z62zc3z04anonymousza31213ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_444, obj_t BgL_oz00_445, obj_t BgL_vz00_446)
{
{ /* Llib/gstelementfactory.scm 28 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_445), 
(int)(8L), BgL_vz00_446);} 

}



/* &<@anonymous:1212> */
obj_t BGl_z62zc3z04anonymousza31212ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_447, obj_t BgL_oz00_448)
{
{ /* Llib/gstelementfactory.scm 28 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_448), 
(int)(8L));} 

}



/* &<@anonymous:1206> */
obj_t BGl_z62zc3z04anonymousza31206ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_449, obj_t BgL_oz00_450, obj_t BgL_vz00_451)
{
{ /* Llib/gstelementfactory.scm 28 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_450), 
(int)(7L), BgL_vz00_451);} 

}



/* &<@anonymous:1205> */
obj_t BGl_z62zc3z04anonymousza31205ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_452, obj_t BgL_oz00_453)
{
{ /* Llib/gstelementfactory.scm 28 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_453), 
(int)(7L));} 

}



/* &<@anonymous:1201> */
obj_t BGl_z62zc3z04anonymousza31201ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_454, obj_t BgL_oz00_455, obj_t BgL_vz00_456)
{
{ /* Llib/gstelementfactory.scm 28 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_455), 
(int)(6L), BgL_vz00_456);} 

}



/* &<@anonymous:1200> */
obj_t BGl_z62zc3z04anonymousza31200ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_457, obj_t BgL_oz00_458)
{
{ /* Llib/gstelementfactory.scm 28 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_458), 
(int)(6L));} 

}



/* &<@anonymous:1196> */
obj_t BGl_z62zc3z04anonymousza31196ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_459, obj_t BgL_oz00_460, obj_t BgL_vz00_461)
{
{ /* Llib/gstelementfactory.scm 28 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_460), 
(int)(5L), BgL_vz00_461);} 

}



/* &<@anonymous:1195> */
obj_t BGl_z62zc3z04anonymousza31195ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_462, obj_t BgL_oz00_463)
{
{ /* Llib/gstelementfactory.scm 28 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_463), 
(int)(5L));} 

}



/* &<@anonymous:1190> */
obj_t BGl_z62zc3z04anonymousza31190ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_464, obj_t BgL_oz00_465, obj_t BgL_vz00_466)
{
{ /* Llib/gstelementfactory.scm 28 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_465), 
(int)(4L), BgL_vz00_466);} 

}



/* &<@anonymous:1189> */
obj_t BGl_z62zc3z04anonymousza31189ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_467, obj_t BgL_oz00_468)
{
{ /* Llib/gstelementfactory.scm 28 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_468), 
(int)(4L));} 

}



/* &<@anonymous:1182> */
obj_t BGl_z62zc3z04anonymousza31182ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_469, obj_t BgL_oz00_470, obj_t BgL_vz00_471)
{
{ /* Llib/gstelementfactory.scm 28 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_470), 
(int)(3L), BgL_vz00_471);} 

}



/* &<@anonymous:1181> */
obj_t BGl_z62zc3z04anonymousza31181ze3ze5zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_472, obj_t BgL_oz00_473)
{
{ /* Llib/gstelementfactory.scm 28 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_473), 
(int)(3L));} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__gstreamer_gstelementfactoryz00(void)
{
{ /* Llib/gstelementfactory.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__gstreamer_gstelementfactoryz00(void)
{
{ /* Llib/gstelementfactory.scm 15 */
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2displayzd2envz00zz__objectz00, BGl_gstzd2elementzd2factoryz00zz__gstreamer_gstelementfactoryz00, BGl_proc1429z00zz__gstreamer_gstelementfactoryz00, BGl_string1430z00zz__gstreamer_gstelementfactoryz00);} 

}



/* &object-display-gst-e1085 */
obj_t BGl_z62objectzd2displayzd2gstzd2e1085zb0zz__gstreamer_gstelementfactoryz00(obj_t BgL_envz00_477, obj_t BgL_oz00_478, obj_t BgL_portz00_479)
{
{ /* Llib/gstelementfactory.scm 94 */
{ /* Llib/gstelementfactory.scm 96 */
 obj_t BgL_pz00_548;
if(
PAIRP(BgL_portz00_479))
{ /* Llib/gstelementfactory.scm 96 */
BgL_pz00_548 = 
CAR(BgL_portz00_479); }  else 
{ /* Llib/gstelementfactory.scm 96 */
 obj_t BgL_tmpz00_1018;
BgL_tmpz00_1018 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_pz00_548 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1018); } 
{ /* Llib/gstelementfactory.scm 97 */
 obj_t BgL_tmpz00_1021;
BgL_tmpz00_1021 = 
((obj_t)BgL_pz00_548); 
bgl_display_string(BGl_string1431z00zz__gstreamer_gstelementfactoryz00, BgL_tmpz00_1021); } 
{ /* Llib/gstelementfactory.scm 98 */
 obj_t BgL_arg1359z00_549;
BgL_arg1359z00_549 = 
bgl_find_runtime_type(
((obj_t)
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_oz00_478))); 
bgl_display_obj(BgL_arg1359z00_549, BgL_pz00_548); } 
{ /* Llib/gstelementfactory.scm 99 */
 obj_t BgL_tmpz00_1028;
BgL_tmpz00_1028 = 
((obj_t)BgL_pz00_548); 
bgl_display_string(BGl_string1432z00zz__gstreamer_gstelementfactoryz00, BgL_tmpz00_1028); } 
{ /* Llib/gstelementfactory.scm 101 */
 int BgL_arg1360z00_550;
{ /* Llib/gstelementfactory.scm 101 */
 GstObject * BgL_arg1361z00_551;
BgL_arg1361z00_551 = 
(((BgL_gstzd2objectzd2_bglt)COBJECT(
((BgL_gstzd2objectzd2_bglt)
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_oz00_478))))->BgL_z42builtinz42); 
BgL_arg1360z00_550 = 
GST_OBJECT_REFCOUNT(BgL_arg1361z00_551); } 
bgl_display_obj(
BINT(BgL_arg1360z00_550), BgL_pz00_548); } 
{ /* Llib/gstelementfactory.scm 102 */
 obj_t BgL_tmpz00_1037;
BgL_tmpz00_1037 = 
((obj_t)BgL_pz00_548); 
bgl_display_string(BGl_string1433z00zz__gstreamer_gstelementfactoryz00, BgL_tmpz00_1037); } 
{ /* Llib/gstelementfactory.scm 103 */
 obj_t BgL_arg1362z00_552;
BgL_arg1362z00_552 = 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)
((BgL_gstzd2elementzd2factoryz00_bglt)BgL_oz00_478)), 
(int)(3L)); 
bgl_display_obj(BgL_arg1362z00_552, BgL_pz00_548); } 
{ /* Llib/gstelementfactory.scm 104 */
 obj_t BgL_tmpz00_1045;
BgL_tmpz00_1045 = 
((obj_t)BgL_pz00_548); 
return 
bgl_display_string(BGl_string1434z00zz__gstreamer_gstelementfactoryz00, BgL_tmpz00_1045);} } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__gstreamer_gstelementfactoryz00(void)
{
{ /* Llib/gstelementfactory.scm 15 */
BGl_modulezd2initializa7ationz75zz__gstreamer_gstpluginfeaturez00(56414833L, 
BSTRING_TO_STRING(BGl_string1435z00zz__gstreamer_gstelementfactoryz00)); 
BGl_modulezd2initializa7ationz75zz__gstreamer_gstelementz00(252539642L, 
BSTRING_TO_STRING(BGl_string1435z00zz__gstreamer_gstelementfactoryz00)); 
return 
BGl_modulezd2initializa7ationz75zz__gstreamer_gstpadz00(22461199L, 
BSTRING_TO_STRING(BGl_string1435z00zz__gstreamer_gstelementfactoryz00));} 

}

#ifdef __cplusplus
}
#endif
