/*===========================================================================*/
/*   (Misc/make_lib.scm)                                                     */
/*   Bigloo (4.6a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Jan 27 07:55:05 AM CET 2025     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/bin/bigloo -ldopt -L/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/libbacktrace/usr/lib64/bigloo/4.6a  -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/lib/bigloo/4.6a -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/lib/bigloo/4.6a -unsafe -safee -copt -fPIC -copt -IPosix Misc/make_lib.scm -o objs/make_lib.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* unsafe mode */
#define BIGLOO_UNSAFE 1

/* traces mode */
#define BIGLOO_TRACE 0

/* standard Bigloo include */
#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif
#ifndef BGL_MODULE_TYPE_DEFINITIONS
#define BGL_MODULE_TYPE_DEFINITIONS
#ifndef BGL___MAIL_MAKELIB_TYPE_DEFINITIONS
#define BGL___MAIL_MAKELIB_TYPE_DEFINITIONS
#endif // BGL___MAIL_MAKELIB_TYPE_DEFINITIONS
#endif // BGL_MODULE_TYPE_DEFINITIONS

static obj_t BGl_requirezd2initializa7ationz75zz__mail_makelibz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_z62imapzd2parsezd2errorz62zz__mail_imapz00;
static obj_t BGl_toplevelzd2initzd2zz__mail_makelibz00(void);
static obj_t BGl_genericzd2initzd2zz__mail_makelibz00(void);
extern obj_t BGl_vcardz00zz__mail_vcardz00;
static obj_t BGl_objectzd2initzd2zz__mail_makelibz00(void);
BGL_IMPORT obj_t BGl_evalzd2expandzd2duplicatez00zz__evobjectz00(obj_t);
static obj_t BGl_evalzd2initzd2zz__mail_makelibz00(void);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__mail_makelibz00(void);
BGL_IMPORT obj_t BGl_definezd2primopzd2refz12z12zz__evenvz00(obj_t, obj_t);
extern obj_t BGl_maildirz00zz__mail_maildirz00;
extern obj_t BGl_mailboxz00zz__mail_mailboxz00;
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__mail_makelibz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mail_vcardz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mail_rfc2822z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mail_rfc2047z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mail_rfc2045z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mail_imapz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mail_maildirz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mail_mailboxz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__evobjectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_evalzd2expandzd2instantiatez00zz__evobjectz00(obj_t);
static obj_t BGl_cnstzd2initzd2zz__mail_makelibz00(void);
static obj_t BGl_libraryzd2moduleszd2initz00zz__mail_makelibz00(void);
static obj_t BGl_importedzd2moduleszd2initz00zz__mail_makelibz00(void);
static obj_t BGl_gczd2rootszd2initz00zz__mail_makelibz00(void);
BGL_IMPORT obj_t BGl_definezd2primopz12zc0zz__evenvz00(obj_t, obj_t);
static obj_t BGl_z62appendzd221010zb0zz__mail_makelibz00(obj_t, obj_t, obj_t);
extern obj_t BGl_z62imapzd2errorzb0zz__mail_imapz00;
extern obj_t BGl_z62mailboxzd2errorzb0zz__mail_mailboxz00;
BGL_IMPORT obj_t BGl_evalzd2expandzd2withzd2accesszd2zz__evobjectz00(obj_t);
extern obj_t BGl_z62maildirzd2errorzb0zz__mail_maildirz00;
extern obj_t BGl_imapz00zz__mail_imapz00;
static obj_t __cnst[ 117 ] ;


extern obj_t BGl_imapzd2messagezd2headerza2zd2envz70zz__mail_imapz00;
extern obj_t BGl_mailboxzd2folderzd2renamez12zd2envzc0zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2messagezd2headerzd2listzd2envz00zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2messagezd2movez12zd2envzc0zz__mail_mailboxz00;
extern obj_t BGl_imapzd2separatorzd2envz00zz__mail_imapz00;
extern obj_t BGl_imapzd2loginzd2envz00zz__mail_imapz00;
extern obj_t BGl_mailboxzd2folderzd2createz12zd2envzc0zz__mail_mailboxz00;
extern obj_t BGl_quotedzd2printablezd2encodezd2envzd2zz__mail_rfc2045z00;
extern obj_t BGl_mailboxzd2messagezd2deletez12zd2envzc0zz__mail_mailboxz00;
extern obj_t BGl_imapzd2folderzd2unsubscribez12zd2envzc0zz__mail_imapz00;
extern obj_t BGl_mailboxzd2prefixzd2envz00zz__mail_mailboxz00;
extern obj_t BGl_rfc2822zd2addresszd2displayzd2namezd2envz00zz__mail_rfc2822z00;
extern obj_t BGl_mimezd2contentzd2dispositionzd2decodezd2envz00zz__mail_rfc2045z00;
extern obj_t BGl_mailboxzd2folderzd2searchzd2keywordzd2envz00zz__mail_mailboxz00;
extern obj_t BGl_imapzd2messagezd2headerzd2envzd2zz__mail_imapz00;
extern obj_t BGl_imapzd2messagezd2createz12zd2envzc0zz__mail_imapz00;
extern obj_t BGl_mimezd2contentzd2typezd2decodezd2portzd2envzd2zz__mail_rfc2045z00;
extern obj_t BGl_mailboxzd2folderzd2flagszd2envzd2zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2folderzd2siza7eszd2envz75zz__mail_mailboxz00;
extern obj_t BGl_imapzd2messagezd2infozd2envzd2zz__mail_imapz00;
extern obj_t BGl_mailboxzd2folderzd2messageszd2envzd2zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2folderzd2headerszd2envzd2zz__mail_mailboxz00;
extern obj_t BGl_imapzd2folderszd2envz00zz__mail_imapz00;
extern obj_t BGl_mailboxzd2closezd2envz00zz__mail_mailboxz00;
extern obj_t BGl_imapzd2messagezd2unflaggedz12zd2envzc0zz__mail_imapz00;
extern obj_t BGl_imapzd2messagezd2copyz12zd2envzc0zz__mail_imapz00;
extern obj_t BGl_mailboxzd2folderzd2selectz12zd2envzc0zz__mail_mailboxz00;
DEFINE_STRING( BGl_string1294z00zz__mail_makelibz00, BgL_bgl_string1294za700za7za7_1326za7, "&append-21010", 13 );
DEFINE_STRING( BGl_string1295z00zz__mail_makelibz00, BgL_bgl_string1295za700za7za7_1327za7, "pair-nil", 8 );
DEFINE_STRING( BGl_string1296z00zz__mail_makelibz00, BgL_bgl_string1296za700za7za7_1328za7, "__mail_makelib", 14 );
DEFINE_STRING( BGl_string1297z00zz__mail_makelibz00, BgL_bgl_string1297za700za7za7_1329za7, "imap-folder-header-fields imap-folder-bodies mailbox-folder-delete-messages! mailbox-message imap-folder-uids &imap-parse-error imap-message-flags-set! mime-content-disposition-decode-port mailbox-folder-subscribe! mailbox-folder-dates mailbox-message-header rfc2047-decode-port mailbox-folder-search-header mailbox-folder-sizes imap-message-delete! imap-message-size vcard mailbox-folder-create! mailbox-message-delete! mailbox-folder-exists? mailbox-prefix imap-folder-poll mailbox-hostname imap-message imap-folder-status email-normalize imap-message-header imap-message-body mail-header->list mailbox-folder-flags mailbox-close imap-folder-create! mailbox-message-flags append-21010 imap-folder-exists? imap-folder-search-header mailbox-folder-search rfc2047-decode mailbox-folder-unsubscribe! imap-message-flagged! imap-message-undelete! quoted-printable-decode imap-folder-internal-dates mailbox-message-header-list mailbox-folder-headers mailbox-folder-infos maildir imap-separator imap-login mime-multipart-decode rf"
"c2822-address-display-name mailbox-message-info mailbox-folder-uids mailbox mime-content-type-decode string->vcard mailbox-separator imap-folder-headers mailbox-folders imap-folder-sizes mailbox-message-flags-set! imap-message-flags mailbox-folder-delete! mime-multipart-decode-port imap-folder-search mailbox-folder-poll imap-folder-expunge! mailbox-folder-move! imap-message-flags-unset! mailbox-folder-rename! mailbox-folder-expunge! mailbox-message-move! mailbox-message-header-field mailbox-message-copy! imap-message-unflagged! quoted-printable-encode imap-folder-unsubscribe! imap-folder-flags imap-logout imap-folder-delete! mailbox-folder-bodies read-vcard mime-content-disposition-decode mailbox-message-size imap-capability imap-message-header-list mailbox-message-path imap-message-create! imap-folder-subscribe! imap-folder-rename! mailbox-message-create! imap-folders &imap-error mailbox-folder-unselect! quoted-printable-encode-port mailbox-folder-header-fields mailbox-message-body mailbox-folder-select! &ma"
"ilbox-error imap-folder-infos imap-folder-select imap-message-header-field mailbox-folder-search-keyword imap-folder-messages &maildir-error port->vcard mime-content-type-decode-port imap-folder-search-keyword imap-message-info imap-message-header* mailbox-folder-messages imap-message-move! imap-message-copy! quoted-printable-decode-port mailbox-folder-status imap-message-flags-change! imap ", 2442 );
extern obj_t BGl_mailboxzd2hostnamezd2envz00zz__mail_mailboxz00;
extern obj_t BGl_imapzd2folderzd2headerzd2fieldszd2envz00zz__mail_imapz00;
extern obj_t BGl_mailzd2headerzd2ze3listzd2envz31zz__mail_rfc2822z00;
extern obj_t BGl_imapzd2messagezd2siza7ezd2envz75zz__mail_imapz00;
extern obj_t BGl_mailboxzd2messagezd2headerzd2fieldzd2envz00zz__mail_mailboxz00;
extern obj_t BGl_imapzd2folderzd2uidszd2envzd2zz__mail_imapz00;
extern obj_t BGl_mailboxzd2messagezd2flagszd2envzd2zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2folderzd2existszf3zd2envz21zz__mail_mailboxz00;
extern obj_t BGl_quotedzd2printablezd2decodezd2portzd2envz00zz__mail_rfc2045z00;
extern obj_t BGl_mailboxzd2folderzd2deletez12zd2envzc0zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2messagezd2infozd2envzd2zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2folderzd2uidszd2envzd2zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2folderzd2searchzd2envzd2zz__mail_mailboxz00;
extern obj_t BGl_imapzd2messagezd2envz00zz__mail_imapz00;
extern obj_t BGl_imapzd2folderzd2infoszd2envzd2zz__mail_imapz00;
extern obj_t BGl_imapzd2folderzd2statuszd2envzd2zz__mail_imapz00;
extern obj_t BGl_mailboxzd2folderzd2unsubscribez12zd2envzc0zz__mail_mailboxz00;
extern obj_t BGl_imapzd2folderzd2bodieszd2envzd2zz__mail_imapz00;
extern obj_t BGl_mailboxzd2folderzd2deletezd2messagesz12zd2envz12zz__mail_mailboxz00;
extern obj_t BGl_imapzd2folderzd2internalzd2dateszd2envz00zz__mail_imapz00;
extern obj_t BGl_imapzd2messagezd2deletez12zd2envzc0zz__mail_imapz00;
extern obj_t BGl_quotedzd2printablezd2encodezd2portzd2envz00zz__mail_rfc2045z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_appendzd221010zd2envz00zz__mail_makelibz00, BgL_bgl_za762appendza7d221011330z00, BGl_z62appendzd221010zb0zz__mail_makelibz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_mimezd2multipartzd2decodezd2envzd2zz__mail_rfc2045z00;
extern obj_t BGl_imapzd2folderzd2searchzd2headerzd2envz00zz__mail_imapz00;
extern obj_t BGl_imapzd2logoutzd2envz00zz__mail_imapz00;
extern obj_t BGl_rfc2047zd2decodezd2envz00zz__mail_rfc2047z00;
extern obj_t BGl_imapzd2folderzd2selectzd2envzd2zz__mail_imapz00;
extern obj_t BGl_mailboxzd2messagezd2siza7ezd2envz75zz__mail_mailboxz00;
extern obj_t BGl_mimezd2contentzd2typezd2decodezd2envz00zz__mail_rfc2045z00;
extern obj_t BGl_imapzd2messagezd2flaggedz12zd2envzc0zz__mail_imapz00;
extern obj_t BGl_mailboxzd2folderzd2dateszd2envzd2zz__mail_mailboxz00;
extern obj_t BGl_imapzd2folderzd2messageszd2envzd2zz__mail_imapz00;
extern obj_t BGl_imapzd2capabilityzd2envz00zz__mail_imapz00;
extern obj_t BGl_imapzd2folderzd2searchzd2keywordzd2envz00zz__mail_imapz00;
extern obj_t BGl_rfc2047zd2decodezd2portzd2envzd2zz__mail_rfc2047z00;
extern obj_t BGl_quotedzd2printablezd2decodezd2envzd2zz__mail_rfc2045z00;
extern obj_t BGl_imapzd2folderzd2renamez12zd2envzc0zz__mail_imapz00;
extern obj_t BGl_mailboxzd2folderzd2expungez12zd2envzc0zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2folderzd2infoszd2envzd2zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2folderzd2unselectz12zd2envzc0zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2messagezd2copyz12zd2envzc0zz__mail_mailboxz00;
extern obj_t BGl_imapzd2folderzd2createz12zd2envzc0zz__mail_imapz00;
extern obj_t BGl_mailboxzd2folderszd2envz00zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2messagezd2headerzd2envzd2zz__mail_mailboxz00;
extern obj_t BGl_imapzd2messagezd2flagszd2unsetz12zd2envz12zz__mail_imapz00;
extern obj_t BGl_imapzd2folderzd2headerszd2envzd2zz__mail_imapz00;
extern obj_t BGl_mailboxzd2folderzd2headerzd2fieldszd2envz00zz__mail_mailboxz00;
extern obj_t BGl_imapzd2messagezd2movez12zd2envzc0zz__mail_imapz00;
extern obj_t BGl_mailboxzd2folderzd2statuszd2envzd2zz__mail_mailboxz00;
extern obj_t BGl_imapzd2messagezd2flagszd2setz12zd2envz12zz__mail_imapz00;
extern obj_t BGl_imapzd2folderzd2pollzd2envzd2zz__mail_imapz00;
extern obj_t BGl_mimezd2contentzd2dispositionzd2decodezd2portzd2envzd2zz__mail_rfc2045z00;
extern obj_t BGl_mailboxzd2folderzd2bodieszd2envzd2zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2folderzd2subscribez12zd2envzc0zz__mail_mailboxz00;
extern obj_t BGl_stringzd2ze3vcardzd2envze3zz__mail_vcardz00;
extern obj_t BGl_imapzd2messagezd2bodyzd2envzd2zz__mail_imapz00;
extern obj_t BGl_imapzd2messagezd2headerzd2listzd2envz00zz__mail_imapz00;
extern obj_t BGl_mailboxzd2messagezd2pathzd2envzd2zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2folderzd2pollzd2envzd2zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2messagezd2envz00zz__mail_mailboxz00;
extern obj_t BGl_imapzd2folderzd2subscribez12zd2envzc0zz__mail_imapz00;
extern obj_t BGl_mailboxzd2separatorzd2envz00zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2messagezd2createz12zd2envzc0zz__mail_mailboxz00;
extern obj_t BGl_imapzd2folderzd2existszf3zd2envz21zz__mail_imapz00;
extern obj_t BGl_imapzd2messagezd2flagszd2changez12zd2envz12zz__mail_imapz00;
extern obj_t BGl_imapzd2folderzd2deletez12zd2envzc0zz__mail_imapz00;
extern obj_t BGl_mailboxzd2messagezd2flagszd2setz12zd2envz12zz__mail_mailboxz00;
extern obj_t BGl_readzd2vcardzd2envz00zz__mail_vcardz00;
extern obj_t BGl_mimezd2multipartzd2decodezd2portzd2envz00zz__mail_rfc2045z00;
extern obj_t BGl_imapzd2messagezd2headerzd2fieldzd2envz00zz__mail_imapz00;
extern obj_t BGl_imapzd2folderzd2expungez12zd2envzc0zz__mail_imapz00;
extern obj_t BGl_mailboxzd2folderzd2movez12zd2envzc0zz__mail_mailboxz00;
extern obj_t BGl_portzd2ze3vcardzd2envze3zz__mail_vcardz00;
extern obj_t BGl_mailboxzd2folderzd2searchzd2headerzd2envz00zz__mail_mailboxz00;
extern obj_t BGl_mailboxzd2messagezd2bodyzd2envzd2zz__mail_mailboxz00;
extern obj_t BGl_imapzd2folderzd2flagszd2envzd2zz__mail_imapz00;
extern obj_t BGl_imapzd2folderzd2siza7eszd2envz75zz__mail_imapz00;
extern obj_t BGl_imapzd2messagezd2flagszd2envzd2zz__mail_imapz00;
extern obj_t BGl_emailzd2normaliza7ezd2envza7zz__mail_rfc2822z00;
extern obj_t BGl_imapzd2folderzd2searchzd2envzd2zz__mail_imapz00;
extern obj_t BGl_imapzd2messagezd2undeletez12zd2envzc0zz__mail_imapz00;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__mail_makelibz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__mail_makelibz00(long BgL_checksumz00_349, char * BgL_fromz00_350)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__mail_makelibz00))
{ 
BGl_requirezd2initializa7ationz75zz__mail_makelibz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__mail_makelibz00(); 
BGl_libraryzd2moduleszd2initz00zz__mail_makelibz00(); 
BGl_cnstzd2initzd2zz__mail_makelibz00(); 
BGl_importedzd2moduleszd2initz00zz__mail_makelibz00(); 
BGl_evalzd2initzd2zz__mail_makelibz00(); 
return 
BGl_toplevelzd2initzd2zz__mail_makelibz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__mail_makelibz00(void)
{
{ /* Misc/make_lib.scm 15 */
BGl_modulezd2initializa7ationz75zz__errorz00(0L, "__mail_makelib"); 
BGl_modulezd2initializa7ationz75zz__evobjectz00(0L, "__mail_makelib"); 
BGl_modulezd2initializa7ationz75zz__readerz00(0L, "__mail_makelib"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(0L, "__mail_makelib"); 
BGl_modulezd2initializa7ationz75zz__evenvz00(0L, "__mail_makelib"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(0L, "__mail_makelib"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(0L, "__mail_makelib"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__mail_makelibz00(void)
{
{ /* Misc/make_lib.scm 15 */
{ /* Misc/make_lib.scm 15 */
 obj_t BgL_cportz00_331;
{ /* Misc/make_lib.scm 15 */
 obj_t BgL_stringz00_338;
BgL_stringz00_338 = BGl_string1297z00zz__mail_makelibz00; 
{ /* Misc/make_lib.scm 15 */
 obj_t BgL_startz00_339;
BgL_startz00_339 = 
BINT(0L); 
{ /* Misc/make_lib.scm 15 */
 obj_t BgL_endz00_340;
BgL_endz00_340 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_338))); 
{ /* Misc/make_lib.scm 15 */

BgL_cportz00_331 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_338, BgL_startz00_339, BgL_endz00_340); } } } } 
{ 
 long BgL_iz00_332;
BgL_iz00_332 = 116L; 
BgL_loopz00_333:
if(
(BgL_iz00_332==(-1L)))
{ /* Misc/make_lib.scm 15 */
return BUNSPEC;}  else 
{ /* Misc/make_lib.scm 15 */
{ /* Misc/make_lib.scm 15 */
 obj_t BgL_arg1325z00_334;
{ /* Misc/make_lib.scm 15 */

{ /* Misc/make_lib.scm 15 */
 obj_t BgL_locationz00_336;
BgL_locationz00_336 = 
BBOOL(((bool_t)0)); 
{ /* Misc/make_lib.scm 15 */

BgL_arg1325z00_334 = 
BGl_readz00zz__readerz00(BgL_cportz00_331, BgL_locationz00_336); } } } 
{ /* Misc/make_lib.scm 15 */
 int BgL_tmpz00_376;
BgL_tmpz00_376 = 
(int)(BgL_iz00_332); 
CNST_TABLE_SET(BgL_tmpz00_376, BgL_arg1325z00_334); } } 
{ /* Misc/make_lib.scm 15 */
 int BgL_auxz00_337;
BgL_auxz00_337 = 
(int)(
(BgL_iz00_332-1L)); 
{ 
 long BgL_iz00_381;
BgL_iz00_381 = 
(long)(BgL_auxz00_337); 
BgL_iz00_332 = BgL_iz00_381; 
goto BgL_loopz00_333;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__mail_makelibz00(void)
{
{ /* Misc/make_lib.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__mail_makelibz00(void)
{
{ /* Misc/make_lib.scm 15 */
return BUNSPEC;} 

}



/* &append-21010 */
obj_t BGl_z62appendzd221010zb0zz__mail_makelibz00(obj_t BgL_envz00_16, obj_t BgL_l1z00_17, obj_t BgL_l2z00_18)
{
{ 
{ 
 obj_t BgL_l1z00_343;
{ 
 bool_t BgL_test1335z00_384;
if(
PAIRP(BgL_l1z00_17))
{ /* Ieee/pairlist.scm 241 */
BgL_test1335z00_384 = ((bool_t)1)
; }  else 
{ /* Ieee/pairlist.scm 241 */
BgL_test1335z00_384 = 
NULLP(BgL_l1z00_17)
; } 
if(BgL_test1335z00_384)
{ 
BgL_l1z00_343 = BgL_l1z00_17; }  else 
{ 
 obj_t BgL_auxz00_388;
BgL_auxz00_388 = 
BGl_typezd2errorzd2zz__errorz00(BFALSE, BFALSE, BGl_string1294z00zz__mail_makelibz00, BGl_string1295z00zz__mail_makelibz00, BgL_l1z00_17); 
FAILURE(BgL_auxz00_388,BFALSE,BFALSE);} } 
if(
NULLP(BgL_l1z00_343))
{ 
return BgL_l2z00_18;}  else 
{ 
 obj_t BgL_headz00_344;
BgL_headz00_344 = 
MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_18); 
{ 
 obj_t BgL_prevz00_346; obj_t BgL_tailz00_347;
BgL_prevz00_346 = BgL_headz00_344; 
BgL_tailz00_347 = BgL_l1z00_343; 
BgL_loopz00_345:
if(
PAIRP(BgL_tailz00_347))
{ 
 obj_t BgL_newzd2prevzd2_348;
BgL_newzd2prevzd2_348 = 
MAKE_YOUNG_PAIR(
CAR(BgL_tailz00_347), BgL_l2z00_18); 
SET_CDR(BgL_prevz00_346, BgL_newzd2prevzd2_348); 
{ 
 obj_t BgL_tailz00_400; obj_t BgL_prevz00_399;
BgL_prevz00_399 = BgL_newzd2prevzd2_348; 
BgL_tailz00_400 = 
CDR(BgL_tailz00_347); 
BgL_tailz00_347 = BgL_tailz00_400; 
BgL_prevz00_346 = BgL_prevz00_399; 
goto BgL_loopz00_345;} }  else 
{ BNIL; } 
return 
CDR(BgL_headz00_344);} } } } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__mail_makelibz00(void)
{
{ /* Misc/make_lib.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__mail_makelibz00(void)
{
{ /* Misc/make_lib.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__mail_makelibz00(void)
{
{ /* Misc/make_lib.scm 15 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__mail_makelibz00(void)
{
{ /* Misc/make_lib.scm 15 */
BGl_modulezd2initializa7ationz75zz__mail_mailboxz00(170844344L, 
BSTRING_TO_STRING(BGl_string1296z00zz__mail_makelibz00)); 
BGl_modulezd2initializa7ationz75zz__mail_maildirz00(255739538L, 
BSTRING_TO_STRING(BGl_string1296z00zz__mail_makelibz00)); 
BGl_modulezd2initializa7ationz75zz__mail_imapz00(89255193L, 
BSTRING_TO_STRING(BGl_string1296z00zz__mail_makelibz00)); 
BGl_modulezd2initializa7ationz75zz__mail_rfc2045z00(361947107L, 
BSTRING_TO_STRING(BGl_string1296z00zz__mail_makelibz00)); 
BGl_modulezd2initializa7ationz75zz__mail_rfc2047z00(502119016L, 
BSTRING_TO_STRING(BGl_string1296z00zz__mail_makelibz00)); 
BGl_modulezd2initializa7ationz75zz__mail_rfc2822z00(421237167L, 
BSTRING_TO_STRING(BGl_string1296z00zz__mail_makelibz00)); 
return 
BGl_modulezd2initializa7ationz75zz__mail_vcardz00(191791834L, 
BSTRING_TO_STRING(BGl_string1296z00zz__mail_makelibz00));} 

}



/* eval-init */
obj_t BGl_evalzd2initzd2zz__mail_makelibz00(void)
{
{ /* Misc/make_lib.scm 15 */
BGl_evalzd2expandzd2instantiatez00zz__evobjectz00(BGl_vcardz00zz__mail_vcardz00); 
BGl_evalzd2expandzd2duplicatez00zz__evobjectz00(BGl_vcardz00zz__mail_vcardz00); 
BGl_evalzd2expandzd2withzd2accesszd2zz__evobjectz00(BGl_vcardz00zz__mail_vcardz00); 
BGl_evalzd2expandzd2instantiatez00zz__evobjectz00(BGl_imapz00zz__mail_imapz00); 
BGl_evalzd2expandzd2duplicatez00zz__evobjectz00(BGl_imapz00zz__mail_imapz00); 
BGl_evalzd2expandzd2withzd2accesszd2zz__evobjectz00(BGl_imapz00zz__mail_imapz00); 
BGl_evalzd2expandzd2instantiatez00zz__evobjectz00(BGl_maildirz00zz__mail_maildirz00); 
BGl_evalzd2expandzd2duplicatez00zz__evobjectz00(BGl_maildirz00zz__mail_maildirz00); 
BGl_evalzd2expandzd2withzd2accesszd2zz__evobjectz00(BGl_maildirz00zz__mail_maildirz00); 
BGl_evalzd2expandzd2withzd2accesszd2zz__evobjectz00(BGl_mailboxz00zz__mail_mailboxz00); 
BGl_definezd2primopzd2refz12z12zz__evenvz00(
((obj_t)
CNST_TABLE_REF(0)), 
__EVMEANING_ADDRESS(
(BGl_imapz00zz__mail_imapz00))); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(1)), BGl_imapzd2messagezd2flagszd2changez12zd2envz12zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(2)), BGl_mailboxzd2folderzd2statuszd2envzd2zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(3)), BGl_quotedzd2printablezd2decodezd2portzd2envz00zz__mail_rfc2045z00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(4)), BGl_imapzd2messagezd2copyz12zd2envzc0zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(5)), BGl_imapzd2messagezd2movez12zd2envzc0zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(6)), BGl_mailboxzd2folderzd2messageszd2envzd2zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(7)), BGl_imapzd2messagezd2headerza2zd2envz70zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(8)), BGl_imapzd2messagezd2infozd2envzd2zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(9)), BGl_imapzd2folderzd2searchzd2keywordzd2envz00zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(10)), BGl_mimezd2contentzd2typezd2decodezd2portzd2envzd2zz__mail_rfc2045z00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(11)), BGl_portzd2ze3vcardzd2envze3zz__mail_vcardz00); 
BGl_definezd2primopzd2refz12z12zz__evenvz00(
((obj_t)
CNST_TABLE_REF(12)), 
__EVMEANING_ADDRESS(
(BGl_z62maildirzd2errorzb0zz__mail_maildirz00))); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(13)), BGl_imapzd2folderzd2messageszd2envzd2zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(14)), BGl_mailboxzd2folderzd2searchzd2keywordzd2envz00zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(15)), BGl_imapzd2messagezd2headerzd2fieldzd2envz00zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(16)), BGl_imapzd2folderzd2selectzd2envzd2zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(17)), BGl_imapzd2folderzd2infoszd2envzd2zz__mail_imapz00); 
BGl_definezd2primopzd2refz12z12zz__evenvz00(
((obj_t)
CNST_TABLE_REF(18)), 
__EVMEANING_ADDRESS(
(BGl_z62mailboxzd2errorzb0zz__mail_mailboxz00))); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(19)), BGl_mailboxzd2folderzd2selectz12zd2envzc0zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(20)), BGl_mailboxzd2messagezd2bodyzd2envzd2zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(21)), BGl_mailboxzd2folderzd2headerzd2fieldszd2envz00zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(22)), BGl_quotedzd2printablezd2encodezd2portzd2envz00zz__mail_rfc2045z00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(23)), BGl_mailboxzd2folderzd2unselectz12zd2envzc0zz__mail_mailboxz00); 
BGl_definezd2primopzd2refz12z12zz__evenvz00(
((obj_t)
CNST_TABLE_REF(24)), 
__EVMEANING_ADDRESS(
(BGl_z62imapzd2errorzb0zz__mail_imapz00))); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(25)), BGl_imapzd2folderszd2envz00zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(26)), BGl_mailboxzd2messagezd2createz12zd2envzc0zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(27)), BGl_imapzd2folderzd2renamez12zd2envzc0zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(28)), BGl_imapzd2folderzd2subscribez12zd2envzc0zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(29)), BGl_imapzd2messagezd2createz12zd2envzc0zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(30)), BGl_mailboxzd2messagezd2pathzd2envzd2zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(31)), BGl_imapzd2messagezd2headerzd2listzd2envz00zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(32)), BGl_imapzd2capabilityzd2envz00zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(33)), BGl_mailboxzd2messagezd2siza7ezd2envz75zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(34)), BGl_mimezd2contentzd2dispositionzd2decodezd2envz00zz__mail_rfc2045z00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(35)), BGl_readzd2vcardzd2envz00zz__mail_vcardz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(36)), BGl_mailboxzd2folderzd2bodieszd2envzd2zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(37)), BGl_imapzd2folderzd2deletez12zd2envzc0zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(38)), BGl_imapzd2logoutzd2envz00zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(39)), BGl_imapzd2folderzd2flagszd2envzd2zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(40)), BGl_imapzd2folderzd2unsubscribez12zd2envzc0zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(41)), BGl_quotedzd2printablezd2encodezd2envzd2zz__mail_rfc2045z00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(42)), BGl_imapzd2messagezd2unflaggedz12zd2envzc0zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(43)), BGl_mailboxzd2messagezd2copyz12zd2envzc0zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(44)), BGl_mailboxzd2messagezd2headerzd2fieldzd2envz00zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(45)), BGl_mailboxzd2messagezd2movez12zd2envzc0zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(46)), BGl_mailboxzd2folderzd2expungez12zd2envzc0zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(47)), BGl_mailboxzd2folderzd2renamez12zd2envzc0zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(48)), BGl_imapzd2messagezd2flagszd2unsetz12zd2envz12zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(49)), BGl_mailboxzd2folderzd2movez12zd2envzc0zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(50)), BGl_imapzd2folderzd2expungez12zd2envzc0zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(51)), BGl_mailboxzd2folderzd2pollzd2envzd2zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(52)), BGl_imapzd2folderzd2searchzd2envzd2zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(53)), BGl_mimezd2multipartzd2decodezd2portzd2envz00zz__mail_rfc2045z00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(54)), BGl_mailboxzd2folderzd2deletez12zd2envzc0zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(55)), BGl_imapzd2messagezd2flagszd2envzd2zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(56)), BGl_mailboxzd2messagezd2flagszd2setz12zd2envz12zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(57)), BGl_imapzd2folderzd2siza7eszd2envz75zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(58)), BGl_mailboxzd2folderszd2envz00zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(59)), BGl_imapzd2folderzd2headerszd2envzd2zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(60)), BGl_mailboxzd2separatorzd2envz00zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(61)), BGl_stringzd2ze3vcardzd2envze3zz__mail_vcardz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(62)), BGl_mimezd2contentzd2typezd2decodezd2envz00zz__mail_rfc2045z00); 
BGl_definezd2primopzd2refz12z12zz__evenvz00(
((obj_t)
CNST_TABLE_REF(63)), 
__EVMEANING_ADDRESS(
(BGl_mailboxz00zz__mail_mailboxz00))); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(64)), BGl_mailboxzd2folderzd2uidszd2envzd2zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(65)), BGl_mailboxzd2messagezd2infozd2envzd2zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(66)), BGl_rfc2822zd2addresszd2displayzd2namezd2envz00zz__mail_rfc2822z00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(67)), BGl_mimezd2multipartzd2decodezd2envzd2zz__mail_rfc2045z00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(68)), BGl_imapzd2loginzd2envz00zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(69)), BGl_imapzd2separatorzd2envz00zz__mail_imapz00); 
BGl_definezd2primopzd2refz12z12zz__evenvz00(
((obj_t)
CNST_TABLE_REF(70)), 
__EVMEANING_ADDRESS(
(BGl_maildirz00zz__mail_maildirz00))); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(71)), BGl_mailboxzd2folderzd2infoszd2envzd2zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(72)), BGl_mailboxzd2folderzd2headerszd2envzd2zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(73)), BGl_mailboxzd2messagezd2headerzd2listzd2envz00zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(74)), BGl_imapzd2folderzd2internalzd2dateszd2envz00zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(75)), BGl_quotedzd2printablezd2decodezd2envzd2zz__mail_rfc2045z00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(76)), BGl_imapzd2messagezd2undeletez12zd2envzc0zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(77)), BGl_imapzd2messagezd2flaggedz12zd2envzc0zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(78)), BGl_mailboxzd2folderzd2unsubscribez12zd2envzc0zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(79)), BGl_rfc2047zd2decodezd2envz00zz__mail_rfc2047z00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(80)), BGl_mailboxzd2folderzd2searchzd2envzd2zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(81)), BGl_imapzd2folderzd2searchzd2headerzd2envz00zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(82)), BGl_imapzd2folderzd2existszf3zd2envz21zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(83)), BGl_appendzd221010zd2envz00zz__mail_makelibz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(84)), BGl_mailboxzd2messagezd2flagszd2envzd2zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(85)), BGl_imapzd2folderzd2createz12zd2envzc0zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(86)), BGl_mailboxzd2closezd2envz00zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(87)), BGl_mailboxzd2folderzd2flagszd2envzd2zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(88)), BGl_mailzd2headerzd2ze3listzd2envz31zz__mail_rfc2822z00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(89)), BGl_imapzd2messagezd2bodyzd2envzd2zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(90)), BGl_imapzd2messagezd2headerzd2envzd2zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(91)), BGl_emailzd2normaliza7ezd2envza7zz__mail_rfc2822z00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(92)), BGl_imapzd2folderzd2statuszd2envzd2zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(93)), BGl_imapzd2messagezd2envz00zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(94)), BGl_mailboxzd2hostnamezd2envz00zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(95)), BGl_imapzd2folderzd2pollzd2envzd2zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(96)), BGl_mailboxzd2prefixzd2envz00zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(97)), BGl_mailboxzd2folderzd2existszf3zd2envz21zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(98)), BGl_mailboxzd2messagezd2deletez12zd2envzc0zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(99)), BGl_mailboxzd2folderzd2createz12zd2envzc0zz__mail_mailboxz00); 
BGl_definezd2primopzd2refz12z12zz__evenvz00(
((obj_t)
CNST_TABLE_REF(100)), 
__EVMEANING_ADDRESS(
(BGl_vcardz00zz__mail_vcardz00))); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(101)), BGl_imapzd2messagezd2siza7ezd2envz75zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(102)), BGl_imapzd2messagezd2deletez12zd2envzc0zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(103)), BGl_mailboxzd2folderzd2siza7eszd2envz75zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(104)), BGl_mailboxzd2folderzd2searchzd2headerzd2envz00zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(105)), BGl_rfc2047zd2decodezd2portzd2envzd2zz__mail_rfc2047z00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(106)), BGl_mailboxzd2messagezd2headerzd2envzd2zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(107)), BGl_mailboxzd2folderzd2dateszd2envzd2zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(108)), BGl_mailboxzd2folderzd2subscribez12zd2envzc0zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(109)), BGl_mimezd2contentzd2dispositionzd2decodezd2portzd2envzd2zz__mail_rfc2045z00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(110)), BGl_imapzd2messagezd2flagszd2setz12zd2envz12zz__mail_imapz00); 
BGl_definezd2primopzd2refz12z12zz__evenvz00(
((obj_t)
CNST_TABLE_REF(111)), 
__EVMEANING_ADDRESS(
(BGl_z62imapzd2parsezd2errorz62zz__mail_imapz00))); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(112)), BGl_imapzd2folderzd2uidszd2envzd2zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(113)), BGl_mailboxzd2messagezd2envz00zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(114)), BGl_mailboxzd2folderzd2deletezd2messagesz12zd2envz12zz__mail_mailboxz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(115)), BGl_imapzd2folderzd2bodieszd2envzd2zz__mail_imapz00); 
BGl_definezd2primopz12zc0zz__evenvz00(
((obj_t)
CNST_TABLE_REF(116)), BGl_imapzd2folderzd2headerzd2fieldszd2envz00zz__mail_imapz00); 
return BUNSPEC;} 

}

#ifdef __cplusplus
}
#endif
