/*===========================================================================*/
/*   (Llib/mqtt.scm)                                                         */
/*   Bigloo (4.6a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Jan 27 07:55:05 AM CET 2025     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/bin/bigloo -ldopt -L/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/libbacktrace/usr/lib64/bigloo/4.6a  -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/lib/bigloo/4.6a -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/lib/bigloo/4.6a -srfi mqtt -safee -g -unsafe -copt -fPIC -copt -IPosix Llib/mqtt.scm -o objs/mqtt.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

/* unsafe mode */
#define BIGLOO_UNSAFE 1

/* traces mode */
#define BIGLOO_TRACE 1

/* standard Bigloo include */
#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif
#ifndef BGL_MODULE_TYPE_DEFINITIONS
#define BGL_MODULE_TYPE_DEFINITIONS
#ifndef BGL___MQTT_MQTT_TYPE_DEFINITIONS
#define BGL___MQTT_MQTT_TYPE_DEFINITIONS
#endif // BGL___MQTT_MQTT_TYPE_DEFINITIONS
#endif // BGL_MODULE_TYPE_DEFINITIONS

static obj_t BGl_requirezd2initializa7ationz75zz__mqtt_mqttz00 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zz__mqtt_mqttz00(void);
static obj_t BGl_genericzd2initzd2zz__mqtt_mqttz00(void);
static obj_t BGl_objectzd2initzd2zz__mqtt_mqttz00(void);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__mqtt_mqttz00(void);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__mqtt_mqttz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mqtt_clientz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mqtt_serverz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__mqtt_commonz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
static obj_t BGl_cnstzd2initzd2zz__mqtt_mqttz00(void);
static obj_t BGl_libraryzd2moduleszd2initz00zz__mqtt_mqttz00(void);
static obj_t BGl_importedzd2moduleszd2initz00zz__mqtt_mqttz00(void);
static obj_t BGl_gczd2rootszd2initz00zz__mqtt_mqttz00(void);
static obj_t __cnst[ 7 ] ;


DEFINE_STRING( BGl_string1080z00zz__mqtt_mqttz00, BgL_bgl_string1080za700za7za7_1083za7, "__mqtt_mqtt", 11 );
DEFINE_STRING( BGl_string1081z00zz__mqtt_mqttz00, BgL_bgl_string1081za700za7za7_1084za7, "%import@__mqtt_mqtt method-init@__mqtt_mqtt generic-init@__mqtt_mqtt object-init@__mqtt_mqtt %toplevel@__mqtt_mqtt (at \"/builddir/build/BUILD/bigloo-4.6a-build/bigloo-4.6a/api/mqtt/src/Llib/mqtt.scm\" 1111) gc-roots-init@__mqtt_mqtt ", 232 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__mqtt_mqttz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__mqtt_mqttz00(long BgL_checksumz00_47, char * BgL_fromz00_48)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__mqtt_mqttz00))
{ 
BGl_requirezd2initializa7ationz75zz__mqtt_mqttz00 = 
BBOOL(((bool_t)0)); 
BGL_GC_INIT(); 
BGl_gczd2rootszd2initz00zz__mqtt_mqttz00(); 
BGl_libraryzd2moduleszd2initz00zz__mqtt_mqttz00(); 
BGl_cnstzd2initzd2zz__mqtt_mqttz00(); 
BGl_importedzd2moduleszd2initz00zz__mqtt_mqttz00(); 
BGl_objectzd2initzd2zz__mqtt_mqttz00(); 
BGl_genericzd2initzd2zz__mqtt_mqttz00(); 
BGl_methodzd2initzd2zz__mqtt_mqttz00(); 
return 
BGl_toplevelzd2initzd2zz__mqtt_mqttz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__mqtt_mqttz00(void)
{
{ /* Llib/mqtt.scm 17 */
BGl_modulezd2initializa7ationz75zz__readerz00(0L, "__mqtt_mqtt"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(0L, "__mqtt_mqtt"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(0L, "__mqtt_mqtt"); 
BGl_modulezd2initializa7ationz75zz__threadz00(0L, "__mqtt_mqtt"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__mqtt_mqttz00(void)
{
{ /* Llib/mqtt.scm 17 */
{ /* Llib/mqtt.scm 17 */
 obj_t BgL_cportz00_36;
{ /* Llib/mqtt.scm 17 */
 obj_t BgL_stringz00_43;
BgL_stringz00_43 = BGl_string1081z00zz__mqtt_mqttz00; 
{ /* Llib/mqtt.scm 17 */
 obj_t BgL_startz00_44;
BgL_startz00_44 = 
BINT(0L); 
{ /* Llib/mqtt.scm 17 */
 obj_t BgL_endz00_45;
BgL_endz00_45 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_43))); 
{ /* Llib/mqtt.scm 17 */

BgL_cportz00_36 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_43, BgL_startz00_44, BgL_endz00_45); } } } } 
{ 
 long BgL_iz00_37;
BgL_iz00_37 = 6L; 
BgL_loopz00_38:
if(
(BgL_iz00_37==(-1L)))
{ /* Llib/mqtt.scm 17 */
return BUNSPEC;}  else 
{ /* Llib/mqtt.scm 17 */
{ /* Llib/mqtt.scm 17 */
 obj_t BgL_arg1082z00_39;
{ /* Llib/mqtt.scm 17 */

{ /* Llib/mqtt.scm 17 */
 obj_t BgL_locationz00_41;
BgL_locationz00_41 = 
BBOOL(((bool_t)0)); 
{ /* Llib/mqtt.scm 17 */

BgL_arg1082z00_39 = 
BGl_readz00zz__readerz00(BgL_cportz00_36, BgL_locationz00_41); } } } 
{ /* Llib/mqtt.scm 17 */
 int BgL_tmpz00_74;
BgL_tmpz00_74 = 
(int)(BgL_iz00_37); 
CNST_TABLE_SET(BgL_tmpz00_74, BgL_arg1082z00_39); } } 
{ /* Llib/mqtt.scm 17 */
 int BgL_auxz00_42;
BgL_auxz00_42 = 
(int)(
(BgL_iz00_37-1L)); 
{ 
 long BgL_iz00_79;
BgL_iz00_79 = 
(long)(BgL_auxz00_42); 
BgL_iz00_37 = BgL_iz00_79; 
goto BgL_loopz00_38;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__mqtt_mqttz00(void)
{
{ /* Llib/mqtt.scm 17 */
{ /* Llib/mqtt.scm 17 */
 obj_t BgL_name1057z00_12; obj_t BgL_loc1058z00_13; obj_t BgL_env1059z00_14;
BgL_name1057z00_12 = 
((obj_t)
CNST_TABLE_REF(0)); 
BgL_loc1058z00_13 = 
((obj_t)
CNST_TABLE_REF(1)); 
BgL_env1059z00_14 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Llib/mqtt.scm 17 */

BGL_ENV_PUSH_TRACE(BgL_env1059z00_14, BgL_name1057z00_12, BgL_loc1058z00_13); 
{ /* Llib/mqtt.scm 17 */
 obj_t BgL_aux1056z00_15;
BgL_aux1056z00_15 = 
bgl_gc_roots_register(); 
BGL_ENV_POP_TRACE(BgL_env1059z00_14); 
return BgL_aux1056z00_15;} } } } 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__mqtt_mqttz00(void)
{
{ /* Llib/mqtt.scm 17 */
{ /* Llib/mqtt.scm 17 */
 obj_t BgL_name1061z00_16; obj_t BgL_loc1062z00_17; obj_t BgL_env1063z00_18;
BgL_name1061z00_16 = 
((obj_t)
CNST_TABLE_REF(2)); 
BgL_loc1062z00_17 = 
((obj_t)
CNST_TABLE_REF(1)); 
BgL_env1063z00_18 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Llib/mqtt.scm 17 */

BGL_ENV_PUSH_TRACE(BgL_env1063z00_18, BgL_name1061z00_16, BgL_loc1062z00_17); 
BGL_ENV_POP_TRACE(BgL_env1063z00_18); 
return BUNSPEC;} } } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__mqtt_mqttz00(void)
{
{ /* Llib/mqtt.scm 17 */
{ /* Llib/mqtt.scm 17 */
 obj_t BgL_name1065z00_20; obj_t BgL_loc1066z00_21; obj_t BgL_env1067z00_22;
BgL_name1065z00_20 = 
((obj_t)
CNST_TABLE_REF(3)); 
BgL_loc1066z00_21 = 
((obj_t)
CNST_TABLE_REF(1)); 
BgL_env1067z00_22 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Llib/mqtt.scm 17 */

BGL_ENV_PUSH_TRACE(BgL_env1067z00_22, BgL_name1065z00_20, BgL_loc1066z00_21); 
BGL_ENV_POP_TRACE(BgL_env1067z00_22); 
return BUNSPEC;} } } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__mqtt_mqttz00(void)
{
{ /* Llib/mqtt.scm 17 */
{ /* Llib/mqtt.scm 17 */
 obj_t BgL_name1069z00_24; obj_t BgL_loc1070z00_25; obj_t BgL_env1071z00_26;
BgL_name1069z00_24 = 
((obj_t)
CNST_TABLE_REF(4)); 
BgL_loc1070z00_25 = 
((obj_t)
CNST_TABLE_REF(1)); 
BgL_env1071z00_26 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Llib/mqtt.scm 17 */

BGL_ENV_PUSH_TRACE(BgL_env1071z00_26, BgL_name1069z00_24, BgL_loc1070z00_25); 
BGL_ENV_POP_TRACE(BgL_env1071z00_26); 
return BUNSPEC;} } } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__mqtt_mqttz00(void)
{
{ /* Llib/mqtt.scm 17 */
{ /* Llib/mqtt.scm 17 */
 obj_t BgL_name1073z00_28; obj_t BgL_loc1074z00_29; obj_t BgL_env1075z00_30;
BgL_name1073z00_28 = 
((obj_t)
CNST_TABLE_REF(5)); 
BgL_loc1074z00_29 = 
((obj_t)
CNST_TABLE_REF(1)); 
BgL_env1075z00_30 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Llib/mqtt.scm 17 */

BGL_ENV_PUSH_TRACE(BgL_env1075z00_30, BgL_name1073z00_28, BgL_loc1074z00_29); 
BGL_ENV_POP_TRACE(BgL_env1075z00_30); 
return BUNSPEC;} } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__mqtt_mqttz00(void)
{
{ /* Llib/mqtt.scm 17 */
{ /* Llib/mqtt.scm 17 */
 obj_t BgL_name1077z00_32; obj_t BgL_loc1078z00_33; obj_t BgL_env1079z00_34;
BgL_name1077z00_32 = 
((obj_t)
CNST_TABLE_REF(6)); 
BgL_loc1078z00_33 = 
((obj_t)
CNST_TABLE_REF(1)); 
BgL_env1079z00_34 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Llib/mqtt.scm 17 */

BGL_ENV_PUSH_TRACE(BgL_env1079z00_34, BgL_name1077z00_32, BgL_loc1078z00_33); 
{ /* Llib/mqtt.scm 17 */
 obj_t BgL_aux1076z00_35;
BGl_modulezd2initializa7ationz75zz__mqtt_commonz00(409833667L, 
BSTRING_TO_STRING(BGl_string1080z00zz__mqtt_mqttz00)); 
BGl_modulezd2initializa7ationz75zz__mqtt_serverz00(11654978L, 
BSTRING_TO_STRING(BGl_string1080z00zz__mqtt_mqttz00)); 
BgL_aux1076z00_35 = 
BGl_modulezd2initializa7ationz75zz__mqtt_clientz00(339158399L, 
BSTRING_TO_STRING(BGl_string1080z00zz__mqtt_mqttz00)); 
BGL_ENV_POP_TRACE(BgL_env1079z00_34); 
return BgL_aux1076z00_35;} } } } 

}

#ifdef __cplusplus
}
#endif
